﻿; -:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-
;
;         Awesomium - Browser Framework based on Chromium
;
;                                         texture example
;
; -:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-
;
; from: 16.02.2012
; Version 0.04.00
;
; {|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}
;
;
; © 2012 by PMV 
; 
;
; {|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}
;
; thread: http://www.purebasic.fr/english/viewtopic.php?f=12&t=48283
;
; description: shows how Awesomium can be used to display it
;              with a texture inside of PB-OGRE. Remember, it
;              is a full browser-engine, so you can display here 
;              everything, what Chrome can render.
;
; You need the Awesomium SDK, install it somewhere and point
; to the library (DLL) shipped with it. Variable Awesomium_Path.s
; is used in this example.
;
; 
; todo: mathcalculation of mouse-position is based on nodes,
;       should be plain calculations to implement this function
;       into include, please see following thread to help me out:
;       http://www.purebasic.fr/english/viewtopic.php?f=13&t=49091
;
;                                                 Thank You! :-)
;
; -|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-


IncludeFile #PB_Compiler_Home + "Examples\3D\Screen3DRequester.pb"
EnableExplicit
IncludeFile "Awesomium.pbi"


Structure Awesomium_Plane
  Awesomium.i
  
  Texture.i
  Material.i
  Mesh.i
  Entity.i
  
  Node.i
  NodeX.i
  NodeY.i
  NodeZ.i
  
  SizeX.f
  SizeZ.f
EndStructure



Macro Distance(X1, Z1, X2, Z2)
  Sqr(Pow((X2) - (X1), 2) + Pow((Z2) - (Z1), 2))
EndMacro


Global Quit = #False ;used in Screen3DRequester.pb
Procedure JSCallback(ID.i, ObjectName.s, CallbackName.s, *Arguments)
  Select ObjectName
    Case "btnClose"
      Quit = 1
  EndSelect
EndProcedure



Procedure.f Angle(X.f, Z.f, TargetX.f, TargetZ.f)
  Protected KatheteX.f = TargetX - X, KatheteZ.f = TargetZ - Z
  If KatheteZ < 0 And KatheteX < 0 
    ProcedureReturn Degree(ATan(-KatheteZ/-KatheteX))+180
  ElseIf KatheteZ < 0 And KatheteX > 0 
    ProcedureReturn Degree(ATan(KatheteX/-KatheteZ))+270
  ElseIf KatheteZ > 0 And KatheteX > 0 
    ProcedureReturn Degree(ATan(KatheteZ/KatheteX))
  ElseIf KatheteZ > 0 And KatheteX < 0 
    ProcedureReturn Degree(ATan(-KatheteX/KatheteZ))+90
  ElseIf KatheteZ = 0
    If KatheteX >= 0 : ProcedureReturn 0 : Else : ProcedureReturn 180 : EndIf
  ElseIf KatheteX = 0 
    If KatheteZ >= 0 : ProcedureReturn 90 : Else : ProcedureReturn 270 : EndIf
  EndIf
EndProcedure 


Procedure.i CreateAwesomiumPlane(TexWidth.i, TexHeight.i, SizeX.f, SizeZ.f)
  Protected *AwePlane.Awesomium_Plane = AllocateMemory(SizeOf(Awesomium_Plane))
  
  *AwePlane\Awesomium = CreateAwesomiumTexture(TexWidth.i, TexHeight.i)
  *AwePlane\Texture = Awesomium_GetTexture(*AwePlane\Awesomium)
  *AwePlane\Material = CreateMaterial(#PB_Any, TextureID(*AwePlane\Texture))
  MaterialFilteringMode(*AwePlane\Material, #PB_Material_None)
  MaterialBlendingMode(*AwePlane\Material, #PB_Material_AlphaBlend)
  MaterialAmbientColor(*AwePlane\Material, $FFFFFF)
  MaterialSelfIlluminationColor(*AwePlane\Material, $FFFFFF)
  MaterialDepthWrite(*AwePlane\Material, #False)
  
  *AwePlane\Mesh = CreatePlane(#PB_Any, SizeX, SizeZ, 1, 1, 1, 1)
  *AwePlane\Entity = CreateEntity(#PB_Any, MeshID(*AwePlane\Mesh), MaterialID(*AwePlane\Material))
  
  *AwePlane\Node = CreateNode(#PB_Any)
  *AwePlane\NodeX = CreateNode(#PB_Any, 1, 0, 0)
  *AwePlane\NodeY = CreateNode(#PB_Any, 0, 0, -1)
  *AwePlane\NodeZ = CreateNode(#PB_Any, 0, 1, 0)
  
  AttachNodeObject(*AwePlane\Node, NodeID(*AwePlane\NodeX), #PB_Node_Node)
  AttachNodeObject(*AwePlane\Node, NodeID(*AwePlane\NodeY), #PB_Node_Node)
  AttachNodeObject(*AwePlane\Node, NodeID(*AwePlane\NodeZ), #PB_Node_Node)
  AttachNodeObject(*AwePlane\Node, EntityID(*AwePlane\Entity), #PB_Node_Entity) 
  
  *AwePlane\SizeX = SizeX
  *AwePlane\SizeZ = SizeZ
  
  ProcedureReturn *AwePlane
EndProcedure

; many thanks to Comtois!
; http://www.purebasic.fr/english/viewtopic.php?f=13&t=49091
Procedure Awesomium_InjectMousePosPlane(*AwePlane.Awesomium_Plane, CameraID.i, MouseX.i, MouseY.i)
  Protected.d X0, Y0, Z0, Xd, Yd, Zd
  Protected.d Nx, Ny, Nz, Px0, Py0, Pz0
  Protected.d numerator, denominator, schar, t
  Protected.d LayerX, LayerY, LayerZ
  
;   Static EntityPoint.i
;   If Not EntityPoint
;     Protected MaterialPoint.i = CreateMaterial(#PB_Any, TextureID(LoadTexture(#PB_Any, "Wood.jpg")))
;     EntityPoint = CreateEntity(#PB_Any, MeshID(CreateSphere(#PB_Any, 1)), MaterialID(MaterialPoint), 0, 0, 0)
;   EndIf  
  
  If PointPick(CameraID, MouseX, MouseY)
    ; startpoint of beam
    X0 = CameraX(CameraID)
    Y0 = CameraY(CameraID)
    Z0 = CameraZ(CameraID)
    
    ; beam-direction
    Xd = PickX()
    Yd = PickY()
    Zd = PickZ()
    
    
    ;normal of plane
    Nx = NodeX(*AwePlane\NodeZ) - NodeX(*AwePlane\Node)
    Ny = NodeY(*AwePlane\NodeZ) - NodeY(*AwePlane\Node)
    Nz = NodeZ(*AwePlane\NodeZ) - NodeZ(*AwePlane\Node)
    
    ; random point of the plane
    Px0 = -NodeX(*AwePlane\Node)
    Py0 = -NodeY(*AwePlane\Node)
    Pz0 = -NodeZ(*AwePlane\Node)
    
    ; calculating the schar from the plane
    schar = Nx * Px0 + Ny * Py0 + Nz * Pz0
    
    
    ; check if beam is not parallel to plane (= 0)
    denominator = Nx * Xd + Ny * Yd + Nz * Zd 
    If denominator <> 0
      numerator = Nx * X0 + Ny * Y0 + Nz * Z0 + schar
      t = -numerator / denominator
      
      ; calculate if plane is before camera (> 0)
      If t > 0
        ;click-coordinates in 3d-world on plane
        LayerX = X0 + t * Xd
        LayerY = Y0 + t * Yd
        LayerZ = Z0 + t * Zd
        ;EntityLocate(EntityPoint, LayerX, LayerY, LayerZ)
        
        LayerX = LayerX - NodeX(*AwePlane\Node)
        LayerY = LayerY - NodeY(*AwePlane\Node)
        LayerZ = LayerZ - NodeZ(*AwePlane\Node)
        
        MouseX = (NodeX(*AwePlane\NodeX) - NodeX(*AwePlane\Node)) * LayerX + (NodeY(*AwePlane\NodeX) - NodeY(*AwePlane\Node)) * LayerY + (NodeZ(*AwePlane\NodeX) - NodeZ(*AwePlane\Node)) * LayerZ
        MouseY = (NodeX(*AwePlane\NodeY) - NodeX(*AwePlane\Node)) * LayerX + (NodeY(*AwePlane\NodeY) - NodeY(*AwePlane\Node)) * LayerY + (NodeZ(*AwePlane\NodeY) - NodeZ(*AwePlane\Node)) * LayerZ
        ;Z = 0 = (NodeX(*AwePlane\NodeZ) - NodeX(*AwePlane\Node)) * LayerX + (NodeY(*AwePlane\NodeZ) - NodeY(*AwePlane\Node)) * LayerY + (NodeZ(*AwePlane\NodeZ) - NodeZ(*AwePlane\Node)) * LayerZ
        
        ;calculate world-units into pixel of texture
        MouseX = 1024 - (MouseX + *AwePlane\SizeX/2) / *AwePlane\SizeX * 1024
        MouseY =        (MouseY + *AwePlane\SizeZ/2) / *AwePlane\SizeZ * 1024
        ;Debug Str(MouseX) + ", " + Str(MouseY)
        
        Awesomium_InjectMousePos(*AwePlane\Awesomium, Int(MouseX), Int(MouseY))
      EndIf
    EndIf
  EndIf
EndProcedure


; change this if you want to point to self downloaded installation of Awesomium
;Define Awesomium_Path.s = "<Awesomium SDK>\<Version>\build\bin\release\Awesomium.dll"
Define Awesomium_Path.s = GetPathPart(ProgramFilename()) + "Data\Awesomium\Awesomium.dll"


Define.f KeyX, KeyY, KeyZ, MouseX, MouseY
Define.f Angle, AngleY, Distance
Define.i MouseSprite, CameraID

Define.f X = 50, Y = 50, Z = 50
Define *AwePlane.Awesomium_Plane



SetCurrentDirectory(GetPathPart(ProgramFilename()))
InitAwesomium(Awesomium_Path, "Awesomium - Test3D", #True, GetPathPart(ProgramFilename()) + "Data")
SetCurrentDirectory(#PB_Compiler_Home + "Examples\3D\")

If InitEngine3D()
   
  InitSprite()
  InitKeyboard()
  InitMouse()
  
  ; needed because CreateTexture() doesn't have alpha
  UsePNGImageEncoder()
  UsePNGImageDecoder()
  Add3DArchive(GetTemporaryDirectory(), #PB_3DArchive_FileSystem)
  ; ------
  
  If Screen3DRequester()
    ; plane for awesomium-texture inside of the 3D-world
    ; important: texture needs to be 2^x, width and height don't need to be same
    *AwePlane = CreateAwesomiumPlane(1024, 1024, 100, 100)
    NodeLocate(*AwePlane\Node, X, Y, Z)
    ; ----
    
    Awesomium_LoadFile(*AwePlane\Awesomium, "Main.html")
    ;Awesomium_LoadUrl(*AwePlane\Awesomium, "http://www.purebasic.com")
    Awesomium_RegisterObject(*AwePlane\Awesomium, "btnClose")
    Awesomium_RegisterObjectCallback(*AwePlane\Awesomium, "btnClose", "close")
    Awesomium_Callback(*AwePlane\Awesomium, #Awe_Callback_JSCallback, @JSCallback())

    
    
    Add3DArchive(#PB_Compiler_Home + "Examples\3D\Data\Textures", #PB_3DArchive_FileSystem)
    SkyDome("clouds.jpg", 30)
    
    
    MouseSprite = CreateSprite(#PB_Any, 8, 8)
    StartDrawing(SpriteOutput(MouseSprite))
      Box(0, 0, 7, 7, 0)
      Circle(3, 3, 2, RGB(4, 4, 4))
      Box(3, 3, 1, 1, RGB(255, 255, 255))
    StopDrawing()
    TransparentSpriteColor(MouseSprite, 0)  
    
    ; Camera
    CameraID = CreateCamera(#PB_Any, 0, 0, 100, 100)
    CameraLocate(CameraID, 50, 50, 100)
    CameraLookAt(CameraID, 0, 0, 0)
    
 
    Repeat
      Awesomium_Update()
      Screen3DEvents()
      
      If KeyboardPushed(#PB_Key_Left)
        KeyX = -1
      ElseIf KeyboardPushed(#PB_Key_Right)
        KeyX = 1
      Else
        KeyX = 0
      EndIf
      
      If KeyboardPushed(#PB_Key_Up)
        KeyZ = -1
      ElseIf KeyboardPushed(#PB_Key_Down)
        KeyZ = 1
      Else
        KeyZ = 0
      EndIf
      
      If ExamineMouse()
        MouseX = -MouseDeltaX()/10 
        MouseY = -MouseDeltaY()/10
      EndIf
         
      
      RotateCamera(CameraID, MouseY, MouseX, 0, #PB_Relative)
      MoveCamera  (CameraID, KeyX, 0, KeyZ)
      
       ; set orientation of awesomium-plane
      Distance = Distance(X, Z, CameraX(CameraID), CameraZ(CameraID))
      Angle = Angle(X, Z, CameraX(CameraID), CameraZ(CameraID))
      AngleY = Angle(0, Y, Distance, CameraY(CameraID))
      RotateNode(*AwePlane\Node, 0, -Angle,  AngleY-90, #PB_Absolute)
      RotateNode(*AwePlane\Node, 0, -90,  0, #PB_Relative)
      
      RenderWorld()
      Screen3DStats()
      
      DisplayTransparentSprite(MouseSprite, MouseX()-3, MouseY()-3)
      Awesomium_InjectMousePosPlane(*AwePlane, CameraID, MouseX(), MouseY())
      Awesomium_InjectMouseButtonDX(*AwePlane\Awesomium)
      ;SetWindowTitle(#WINDOW_Screen3DRequester, "Awesomium - Test (" + Str(Engine3DFrameRate(#PB_Engine3D_Current)) + ")")
      
      FlipBuffers()
      
    Until KeyboardPushed(#PB_Key_Escape) Or Quit = 1
    awe_webcore_shutdown()
  EndIf
  
  
Else
  MessageRequester("Error", "The 3D Engine can't be initialized",0)
EndIf

End
; IDE Options = PureBasic 4.60 (Windows - x86)
; CursorPosition = 111
; FirstLine = 80
; Folding = -
; EnableUnicode
; EnableXP
; DisableDebugger
; CompileSourceDirectory