﻿; -:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-
;
;         Awesomium - Browser Framework based on Chromium
;
;                                         for PureBasic v4.60+
;
; -:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-
;
; from: 26.06.2012
; Version 0.05.00
;
; {|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}
;
;
; © 2011+2012 by PMV 
; 
;
; {|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}
;
; Please note: include still in development, please checkout
;              examples and documentation of awesomium for help
;
; homepage: http://awesomium.com/
; License: see https://awesomium.com/buy/ (possibly free)
; download: http://awesomium.com/download/
; documentation: http://www.awesomium.com/docs/1_6_3/c_api/
; related version: Awesomium SDK 1.6.4 for windows
;
; todo: documentation, more functionality
;       include my JSON_Parser.pbi
;
; -|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-
;
; last changes:
; added: Awesomium_JS_Execute(), Awesomium_JS_Execute_Return_XXX()
; fixed: for ResourceRequestCallback(ID.i, *AweRequest.Awesomium_Request), now *AweRequest\Url returns full URL
; fixed: Display issue for special width/ height values when using Awesomium-Gadget
; added: parameter "PowerOf2" for CreateAwesomiumTexture() to always get a 2^X width and hight for texture
;        will result in free space right and bottom of texture, when width/ height is not 2^X!
; added: parameter "ChildProcessPath" for InitAwesomium() and an OSVersion()-check for windows
; fixed: because of DX9-bug: the alpha-channel is lost for sprites. As a workaround,
;        when using mode #PB_Sprite_AlphaBlending, the whole sprite is repainted always!
;
;

#WM_MOUSEHWHEEL = $020E



Prototype AweP_FileRequesterCallback(ID.i, SelectMultipleFiles.i, Title.s, DefaultPath.s)
Prototype AweP_CursorChangeCallback(ID.i, cursor.i)
Prototype AweP_TitleCallback(ID.i, Title.s, Framename.s)
Prototype AweP_DomReadyCallback(ID.i)
Prototype AweP_JSMessageCallback(ID.i, Message.s, LineNumber.i, Source.s)
Prototype AweP_JSDialogCallback(ID.i, RequestID.i, DialogFlags.i, Message.s, DefaultPrompt.s, FrameUrl.s)
Prototype AweP_DownloadFileCallback(ID.i, DownloadFile.s)
Prototype AweP_OpenExtLinkCallback(ID.i, Url.s, Source.s)
Prototype AweP_OpenNewLinkCallback(ID.i, Url.s, FrameName.s)
Prototype AweP_OpenLinkCallback(ID.i, Url.s)
Prototype AweP_TooltipCallback(ID.i, Tooltip.s)
Prototype AweP_TargetChangeCallback(ID.i, Url.s)
Prototype AweP_BeginLoadingCallback(ID.i, Url.s, FrameName.s, StatusCode.i, MimeType.s)
Prototype AweP_FinishLoadingCallback(ID.i)
Prototype AweP_PageContentsCallback(ID.i, Url.s, Contents.s)
Prototype AweP_CrashedCallback(ID.i)
Prototype AweP_PluginCrashedCallback(ID.i, PluginName.s)
Prototype AweP_FaviconCallback(ID.i, Favicon.i)
Prototype AweP_ResourceCallback(ID.i, Url.s, StatusCode.i, WasCached.i, RequestTimeMS.q, ResponseTimeMS.q, ExpectedContentSize.q, MimeType.s)
Prototype AweP_ShowContextMenu(ID.i, MouseX.i, MouseY.i, Type.i, MediaState.i, LinkUrl.s, SrcUrl.s, PageUrl.s, FrameUrl.s, SelectionText.s, IsEditable.i, EditFlags.i)
Prototype AweP_JSCallback(ID.i, ObjectName.s, CallbackName.s, *Arguments)
Prototype.i AweP_ResourceRequestCallback(ID.i, *AweRequest)

Enumeration
  #AWE_MB_LEFT
  #AWE_MB_MIDDLE
  #AWE_MB_RIGHT
EndEnumeration


Enumeration
  #AWE_CUR_POINTER
  #AWE_CUR_CROSS
  #AWE_CUR_HAND
  #AWE_CUR_IBEAM
  #AWE_CUR_WAIT
  #AWE_CUR_HELP
  #AWE_CUR_EAST_RESIZE
  #AWE_CUR_NORTH_RESIZE
  #AWE_CUR_NORTHEAST_RESIZE
  #AWE_CUR_NORTHWEST_RESIZE
  #AWE_CUR_SOUTH_RESIZE
  #AWE_CUR_SOUTHEAST_RESIZE
  #AWE_CUR_SOUTHWEST_RESIZE
  #AWE_CUR_WEST_RESIZE
  #AWE_CUR_NORTHSOUTH_RESIZE
  #AWE_CUR_EASTWEST_RESIZE
  #AWE_CUR_NORTHEAST_SOUTHWEST_RESIZE
  #AWE_CUR_NORTHWEST_SOUTHEAST_RESIZE
  #AWE_CUR_COLUMN_RESIZE
  #AWE_CUR_ROW_RESIZE
  #AWE_CUR_MIDDLE_PANNING
  #AWE_CUR_EAST_PANNING
  #AWE_CUR_NORTH_PANNING
  #AWE_CUR_NORTHEAST_PANNING
  #AWE_CUR_NORTHWEST_PANNING
  #AWE_CUR_SOUTH_PANNING
  #AWE_CUR_SOUTHEAST_PANNING
  #AWE_CUR_SOUTHWEST_PANNING
  #AWE_CUR_WEST_PANNING
  #AWE_CUR_MOVE
  #AWE_CUR_VERTICAL_TEXT
  #AWE_CUR_CELL
  #AWE_CUR_CONTEXT_MENU
  #AWE_CUR_ALIAS
  #AWE_CUR_PROGRESS
  #AWE_CUR_NO_DROP
  #AWE_CUR_COPY
  #AWE_CUR_NONE
  #AWE_CUR_NOT_ALLOWED
  #AWE_CUR_ZOOM_IN
  #AWE_CUR_ZOOM_OUT
  #AWE_CUR_CUSTOM
EndEnumeration

; typedef enum _awe_loglevel
; {
;         AWE_LL_NONE,
;         AWE_LL_NORMAL,
;         AWE_LL_VERBOSE
; } awe_loglevel;
Enumeration
  #AWE_LL_NONE
  #AWE_LL_NORMAL
  #AWE_LL_VERBOSE
EndEnumeration
  
; typedef enum _awe_webkey_type
; {
;         AWE_WKT_KEYDOWN,
;         AWE_WKT_KEYUP,
;         AWE_WKT_CHAR
; } awe_webkey_type;
Enumeration
  #AWE_WKT_KEYDOWN
  #AWE_WKT_KEYUP
  #AWE_WKT_CHAR
EndEnumeration

; typedef enum _awe_media_type
; {
;         AWE_MEDIA_TYPE_NONE,
;         AWE_MEDIA_TYPE_IMAGE,
;         AWE_MEDIA_TYPE_VIDEO,
;         AWE_MEDIA_TYPE_AUDIO
; } awe_media_type;
Enumeration
  #AWE_MEDIA_TYPE_NONE
  #AWE_MEDIA_TYPE_IMAGE
  #AWE_MEDIA_TYPE_VIDEO
  #AWE_MEDIA_TYPE_AUDIO
EndEnumeration


;{ awe keycodes
		; AK_BACK (08) BACKSPACE key
		#AK_BACK = $08
		
		; AK_TAB (09) TAB key
		#AK_TAB = $09
		
		; AK_CLEAR (0C) CLEAR key
		#AK_CLEAR = $0C
		
		; AK_RETURN (0D)
		#AK_RETURN = $0D
		
		; AK_SHIFT (10) SHIFT key
		#AK_SHIFT = $10
		
		; AK_CONTROL (11) CTRL key
		#AK_CONTROL = $11
		
		; AK_MENU (12) ALT key
		#AK_MENU = $12
		
		; AK_PAUSE (13) PAUSE key
		#AK_PAUSE = $13
		
		; AK_CAPITAL (14) CAPS LOCK key
		#AK_CAPITAL = $14
		
		; AK_KANA (15) Input Method Editor (IME) Kana mode
		#AK_KANA = $15
		
		; AK_HANGUEL (15) IME Hanguel mode (maintained For compatibility use AK_HANGUL)
		; AK_HANGUL (15) IME Hangul mode
		#AK_HANGUL = $15
		
		; AK_JUNJA (17) IME Junja mode
		#AK_JUNJA = $17
		
		; AK_FINAL (18) IME final mode
		#AK_FINAL = $18
		
		; AK_HANJA (19) IME Hanja mode
		#AK_HANJA = $19
		
		; AK_KANJI (19) IME Kanji mode
		#AK_KANJI = $19
		
		; AK_ESCAPE (1B) ESC key
		#AK_ESCAPE = $1B
		
		; AK_CONVERT (1C) IME convert
		#AK_CONVERT = $1C
		
		; AK_NONCONVERT (1D) IME nonconvert
		#AK_NONCONVERT = $1D
		
		; AK_ACCEPT (1E) IME accept
		#AK_ACCEPT = $1E
		
		; AK_MODECHANGE (1F) IME mode change request
		#AK_MODECHANGE = $1F
		
		; AK_SPACE (20) SPACEBAR
		#AK_SPACE = $20
		
		; AK_PRIOR (21) PAGE UP key
		#AK_PRIOR = $21
		
		; AK_NEXT (22) PAGE DOWN key
		#AK_NEXT = $22
		
		; AK_END (23) End key
		#AK_END = $23
		
		; AK_HOME (24) HOME key
		#AK_HOME = $24
		
		; AK_LEFT (25) LEFT ARROW key
		#AK_LEFT = $25
		
		; AK_UP (26) UP ARROW key
		#AK_UP = $26
		
		; AK_RIGHT (27) RIGHT ARROW key
		#AK_RIGHT = $27
		
		; AK_DOWN (28) DOWN ARROW key
		#AK_DOWN = $28
		
		; AK_SELECT (29) Select key
		#AK_SELECT = $29
		
		; AK_PRINT (2A) PRINT key
		#AK_PRINT = $2A
		
		; AK_EXECUTE (2B) EXECUTE key
		#AK_EXECUTE = $2B
		
		; AK_SNAPSHOT (2C) PRINT SCREEN key
		#AK_SNAPSHOT = $2C
		
		; AK_INSERT (2D) INS key
		#AK_INSERT = $2D
		
		; AK_DELETE (2E) DEL key
		#AK_DELETE = $2E
		
		; AK_HELP (2F) HELP key
		#AK_HELP = $2F
		
		; (30) 0 key
		#AK_0 = $30
		
		; (31) 1 key
		#AK_1 = $31
		
		; (32) 2 key
		#AK_2 = $32
		
		; (33) 3 key
		#AK_3 = $33
		
		; (34) 4 key
		#AK_4 = $34
		
		; (35) 5 key
		#AK_5 = $35
		
		; (36) 6 key
		#AK_6 = $36
		
		; (37) 7 key
		#AK_7 = $37
		
		; (38) 8 key
		#AK_8 = $38
		
		; (39) 9 key
		#AK_9 = $39
		
		; (41) A key
		#AK_A = $41
		
		; (42) B key
		#AK_B = $42
		
		; (43) C key
		#AK_C = $43
		
		; (44) D key
		#AK_D = $44
		
		; (45) E key
		#AK_E = $45
		
		; (46) F key
		#AK_F = $46
		
		; (47) G key
		#AK_G = $47
		
		; (48) H key
		#AK_H = $48
		
		; (49) I key
		#AK_I = $49
		
		; (4A) J key
		#AK_J = $4A
		
		; (4B) K key
		#AK_K = $4B
		
		; (4C) L key
		#AK_L = $4C
		
		; (4D) M key
		#AK_M = $4D
		
		; (4E) N key
		#AK_N = $4E
		
		; (4F) O key
		#AK_O = $4F
		
		; (50) P key
		#AK_P = $50
		
		; (51) Q key
		#AK_Q = $51
		
		; (52) R key
		#AK_R = $52
		
		; (53) S key
		#AK_S = $53
		
		; (54) T key
		#AK_T = $54
		
		; (55) U key
		#AK_U = $55
		
		; (56) V key
		#AK_V = $56
		
		; (57) W key
		#AK_W = $57
		
		; (58) X key
		#AK_X = $58
		
		; (59) Y key
		#AK_Y = $59
		
		; (5A) Z key
		#AK_Z = $5A
		
		; AK_LWIN (5B) Left Windows key (Microsoft Natural keyboard)
		#AK_LWIN = $5B
		
		; AK_RWIN (5C) Right Windows key (Natural keyboard)
		#AK_RWIN = $5C
		
		; AK_APPS (5D) Applications key (Natural keyboard)
		#AK_APPS = $5D
		
		; AK_SLEEP (5F) Computer Sleep key
		#AK_SLEEP = $5F
		
		; AK_NUMPAD0 (60) Numeric keypad 0 key
		#AK_NUMPAD0 = $60
		
		; AK_NUMPAD1 (61) Numeric keypad 1 key
		#AK_NUMPAD1 = $61
		
		; AK_NUMPAD2 (62) Numeric keypad 2 key
		#AK_NUMPAD2 = $62
		
		; AK_NUMPAD3 (63) Numeric keypad 3 key
		#AK_NUMPAD3 = $63
		
		; AK_NUMPAD4 (64) Numeric keypad 4 key
		#AK_NUMPAD4 = $64
		
		; AK_NUMPAD5 (65) Numeric keypad 5 key
		#AK_NUMPAD5 = $65
		
		; AK_NUMPAD6 (66) Numeric keypad 6 key
		#AK_NUMPAD6 = $66
		
		; AK_NUMPAD7 (67) Numeric keypad 7 key
		#AK_NUMPAD7 = $67
		
		; AK_NUMPAD8 (68) Numeric keypad 8 key
		#AK_NUMPAD8 = $68
		
		; AK_NUMPAD9 (69) Numeric keypad 9 key
		#AK_NUMPAD9 = $69
		
		; AK_MULTIPLY (6A) Multiply key
		#AK_MULTIPLY = $6A
		
		; AK_ADD (6B) Add key
		#AK_ADD = $6B
		
		; AK_SEPARATOR (6C) Separator key
		#AK_SEPARATOR = $6C
		
		; AK_SUBTRACT (6D) Subtract key
		#AK_SUBTRACT = $6D
		
		; AK_DECIMAL (6E) Decimal key
		#AK_DECIMAL = $6E
		
		; AK_DIVIDE (6F) Divide key
		#AK_DIVIDE = $6F
		
		; AK_F1 (70) F1 key
		#AK_F1 = $70
		
		; AK_F2 (71) F2 key
		#AK_F2 = $71
		
		; AK_F3 (72) F3 key
		#AK_F3 = $72
		
		; AK_F4 (73) F4 key
		#AK_F4 = $73
		
		; AK_F5 (74) F5 key
		#AK_F5 = $74
		
		; AK_F6 (75) F6 key
		#AK_F6 = $75
		
		; AK_F7 (76) F7 key
		#AK_F7 = $76
		
		; AK_F8 (77) F8 key
		#AK_F8 = $77
		
		; AK_F9 (78) F9 key
		#AK_F9 = $78
		
		; AK_F10 (79) F10 key
		#AK_F10 = $79
		
		; AK_F11 (7A) F11 key
		#AK_F11 = $7A
		
		; AK_F12 (7B) F12 key
		#AK_F12 = $7B
		
		; AK_F13 (7C) F13 key
		#AK_F13 = $7C
		
		; AK_F14 (7D) F14 key
		#AK_F14 = $7D
		
		; AK_F15 (7E) F15 key
		#AK_F15 = $7E
		
		; AK_F16 (7F) F16 key
		#AK_F16 = $7F
		
		; AK_F17 (80H) F17 key
		#AK_F17 = $80
		
		; AK_F18 (81H) F18 key
		#AK_F18 = $81
		
		; AK_F19 (82H) F19 key
		#AK_F19 = $82
		
		; AK_F20 (83H) F20 key
		#AK_F20 = $83
		
		; AK_F21 (84H) F21 key
		#AK_F21 = $84
		
		; AK_F22 (85H) F22 key
		#AK_F22 = $85
		
		; AK_F23 (86H) F23 key
		#AK_F23 = $86
		
		; AK_F24 (87H) F24 key
		#AK_F24 = $87
		
		; AK_NUMLOCK (90) NUM LOCK key
		#AK_NUMLOCK = $90
		
		; AK_SCROLL (91) SCROLL LOCK key
		#AK_SCROLL = $91
		
		; AK_LSHIFT (A0) Left SHIFT key
		#AK_LSHIFT = $A0
		
		; AK_RSHIFT (A1) Right SHIFT key
		#AK_RSHIFT = $A1
		
		; AK_LCONTROL (A2) Left CONTROL key
		#AK_LCONTROL = $A2
		
		; AK_RCONTROL (A3) Right CONTROL key
		#AK_RCONTROL = $A3
		
		; AK_LMENU (A4) Left MENU key
		#AK_LMENU = $A4
		
		; AK_RMENU (A5) Right MENU key
		#AK_RMENU = $A5
		
		; AK_BROWSER_BACK (A6) Windows 2000/XP: Browser Back key
		#AK_BROWSER_BACK = $A6
		
		; AK_BROWSER_FORWARD (A7) Windows 2000/XP: Browser Forward key
		#AK_BROWSER_FORWARD = $A7
		
		; AK_BROWSER_REFRESH (A8) Windows 2000/XP: Browser Refresh key
		#AK_BROWSER_REFRESH = $A8
		
		; AK_BROWSER_STOP (A9) Windows 2000/XP: Browser Stop key
		#AK_BROWSER_STOP = $A9
		
		; AK_BROWSER_SEARCH (AA) Windows 2000/XP: Browser Search key
		#AK_BROWSER_SEARCH = $AA
		
		; AK_BROWSER_FAVORITES (AB) Windows 2000/XP: Browser Favorites key
		#AK_BROWSER_FAVORITES = $AB
		
		; AK_BROWSER_HOME (AC) Windows 2000/XP: Browser Start And Home key
		#AK_BROWSER_HOME = $AC
		
		; AK_VOLUME_MUTE (AD) Windows 2000/XP: Volume Mute key
		#AK_VOLUME_MUTE = $AD
		
		; AK_VOLUME_DOWN (AE) Windows 2000/XP: Volume Down key
		#AK_VOLUME_DOWN = $AE
		
		; AK_VOLUME_UP (AF) Windows 2000/XP: Volume Up key
		#AK_VOLUME_UP = $AF
		
		; AK_MEDIA_NEXT_TRACK (B0) Windows 2000/XP: Next Track key
		#AK_MEDIA_NEXT_TRACK = $B0
		
		; AK_MEDIA_PREV_TRACK (B1) Windows 2000/XP: Previous Track key
		#AK_MEDIA_PREV_TRACK = $B1
		
		; AK_MEDIA_STOP (B2) Windows 2000/XP: Stop Media key
		#AK_MEDIA_STOP = $B2
		
		; AK_MEDIA_PLAY_PAUSE (B3) Windows 2000/XP: Play/Pause Media key
		#AK_MEDIA_PLAY_PAUSE = $B3
		
		; AK_LAUNCH_MAIL (B4) Windows 2000/XP: Start Mail key
		#AK_MEDIA_LAUNCH_MAIL = $B4
		
		; AK_LAUNCH_MEDIA_SELECT (B5) Windows 2000/XP: Select Media key
		#AK_MEDIA_LAUNCH_MEDIA_SELECT = $B5
		
		; AK_LAUNCH_APP1 (B6) Windows 2000/XP: Start Application 1 key
		#AK_MEDIA_LAUNCH_APP1 = $B6
		
		; AK_LAUNCH_APP2 (B7) Windows 2000/XP: Start Application 2 key
		#AK_MEDIA_LAUNCH_APP2 = $B7
		
		; AK_OEM_1 (BA) Used For miscellaneous characters; it can vary by keyboard. Windows 2000/XP: For the US standard keyboard, the ';:' key
		#AK_OEM_1 = $BA
		
		; AK_OEM_PLUS (BB) Windows 2000/XP: For any country/region, the '+' key
		#AK_OEM_PLUS = $BB
		
		; AK_OEM_COMMA (BC) Windows 2000/XP: For any country/region, the ',' key
		#AK_OEM_COMMA = $BC
		
		; AK_OEM_MINUS (BD) Windows 2000/XP: For any country/region, the '-' key
		#AK_OEM_MINUS = $BD
		
		; AK_OEM_PERIOD (BE) Windows 2000/XP: For any country/region, the '.' key
		#AK_OEM_PERIOD = $BE
		
		; AK_OEM_2 (BF) Used For miscellaneous characters; it can vary by keyboard. Windows 2000/XP: For the US standard keyboard, the '/?' key
		#AK_OEM_2 = $BF
		
		; AK_OEM_3 (C0) Used For miscellaneous characters; it can vary by keyboard. Windows 2000/XP: For the US standard keyboard, the '`~' key
		#AK_OEM_3 = $C0
		
		; AK_OEM_4 (DB) Used For miscellaneous characters; it can vary by keyboard. Windows 2000/XP: For the US standard keyboard, the '[{' key
		#AK_OEM_4 = $DB
		
		; AK_OEM_5 (DC) Used For miscellaneous characters; it can vary by keyboard. Windows 2000/XP: For the US standard keyboard, the '\|' key
		#AK_OEM_5 = $DC
		
		; AK_OEM_6 (DD) Used For miscellaneous characters; it can vary by keyboard. Windows 2000/XP: For the US standard keyboard, the ']}' key
		#AK_OEM_6 = $DD
		
		; AK_OEM_7 (DE) Used For miscellaneous characters; it can vary by keyboard. Windows 2000/XP: For the US standard keyboard, the 'single-quote/double-quote' key
		#AK_OEM_7 = $DE
		
		; AK_OEM_8 (DF) Used For miscellaneous characters; it can vary by keyboard.
		#AK_OEM_8 = $DF
		
		; AK_OEM_102 (E2) Windows 2000/XP: Either the angle bracket key Or the backslash key on the RT 102-key keyboard
		#AK_OEM_102 = $E2
		
		; AK_PROCESSKEY (E5) Windows 95/98/Me, Windows NT 4.0, Windows 2000/XP: IME PROCESS key
		#AK_PROCESSKEY = $E5
		
		; AK_PACKET (E7) Windows 2000/XP: Used To pass Unicode characters As If they were keystrokes. The AK_PACKET key is the low word of a 32-bit Virtual Key value used For non-keyboard input methods. For more information, see Remark in KEYBDINPUT,SendInput, WM_KEYDOWN, And WM_KEYUP
		#AK_PACKET = $E7
		
		; AK_ATTN (F6) Attn key
		#AK_ATTN = $F6
		
		; AK_CRSEL (F7) CrSel key
		#AK_CRSEL = $F7
		
		; AK_EXSEL (F8) ExSel key
		#AK_EXSEL = $F8
		
		; AK_EREOF (F9) Erase EOF key
		#AK_EREOF = $F9
		
		; AK_PLAY (FA) Play key
		#AK_PLAY = $FA
		
		; AK_ZOOM (FB) Zoom key
		#AK_ZOOM = $FB
		
		; AK_NONAME (FC) Reserved For future use
		#AK_NONAME = $FC
		
		; AK_PA1 (FD) PA1 key
		#AK_PA1 = $FD
		
		; AK_OEM_CLEAR (FE) Clear key
		#AK_OEM_CLEAR = $FE
		
		#AK_UNKNOWN = 0
;} ------


; /// An Enumeration of the different keyboard modifiers.
; enum Modifiers
; {
; 	/// Whether Or Not a Shift key is down
; 	MOD_SHIFT_KEY		= 1 << 0, 
; 
; 	/// Whether Or Not a Control key is down
; 	MOD_CONTROL_KEY		= 1 << 1,
; 
; 	/// Whether Or Not an ALT key is down
; 	MOD_ALT_KEY			= 1 << 2, 
; 
; 	/// Whether Or Not a meta key (Command-key on Mac, Windows-key on Windows) is down
; 	MOD_META_KEY		= 1 << 3, 
; 
; 	/// Whether Or Not the key pressed is on the keypad
; 	MOD_IS_KEYPAD		= 1 << 4,
; 
; 	/// Whether Or Not the character input is the result of an auto-Repeat timer.
; 	MOD_IS_AUTOREPEAT	= 1 << 5, 
; };
#MOD_SHIFT_KEY      = 1 << 0
#MOD_CONTROL_KEY    = 1 << 1
#MOD_ALT_KEY        = 1 << 2
#MOD_META_KEY       = 1 << 3
#MOD_IS_KEYPAD      = 1 << 4
#MOD_IS_AUTOREPEAT  = 1 << 5

; typedef enum _awe_webkey_modifiers
; {
;         AWE_WKM_SHIFT_KEY               = 1 << 0, 
;         AWE_WKM_CONTROL_KEY             = 1 << 1,
;         AWE_WKM_ALT_KEY                 = 1 << 2, 
;         AWE_WKM_META_KEY                = 1 << 3, 
;         AWE_WKM_IS_KEYPAD               = 1 << 4,
;         AWE_WKM_IS_AUTOREPEAT   = 1 << 5, 
; } awe_webkey_modifiers;
#AWE_WKM_SHIFT_KEY      = 1 << 0
#AWE_WKM_CONTROL_KEY    = 1 << 1
#AWE_WKM_ALT_KEY        = 1 << 2
#AWE_WKM_META_KEY       = 1 << 3
#AWE_WKM_IS_KEYPAD      = 1 << 4


; typedef enum _awe_jsvalue_type
; {
;         JSVALUE_TYPE_NULL,
;         JSVALUE_TYPE_BOOLEAN,
;         JSVALUE_TYPE_INTEGER,
;         JSVALUE_TYPE_DOUBLE,
;         JSVALUE_TYPE_STRING,
;         JSVALUE_TYPE_OBJECT,
;         JSVALUE_TYPE_ARRAY
; } awe_jsvalue_type;
Enumeration
  #JSVALUE_TYPE_NULL
  #JSVALUE_TYPE_BOOLEAN
  #JSVALUE_TYPE_INTEGER
  #JSVALUE_TYPE_DOUBLE
  #JSVALUE_TYPE_STRING
  #JSVALUE_TYPE_OBJECT
  #JSVALUE_TYPE_ARRAY
EndEnumeration

Structure BGRA
  Blue.b
  Green.b
  Red.b
  Alpha.b
EndStructure

Structure BGR
  Blue.b
  Green.b
  Red.b
EndStructure


; typedef struct _awe_rect
; {
;        int x, y, width, height;
; } awe_rect;
Structure awe_rect
  x.l
  y.l
  width.l
  height.l
EndStructure


; typedef struct _awe_webkeyboardevent
; {
;         awe_webkey_type type;
;         int modifiers;
;         int virtual_key_code;
;         int native_key_code;
;         wchar16 text[4];
;         wchar16 unmodified_text[4];
;         bool is_system_key;
; } awe_webkeyboardevent;
Structure awe_webkeyboardevent
  type.l
  modifiers.l
  virtual_key_code.l
  native_key_code.l
  text.u[4]
  unmodified_Text.u[4]
  is_system_key.b
EndStructure




; ----------------------------------------------

Enumeration
  #Awe_Type_Gadget
  #Awe_Type_Sprite
  #Awe_Type_Sprite3D
  #Awe_Type_Texture
  #Awe_Type_Window
EndEnumeration


Enumeration
  #Awe_Callback_DomReady        ; called if DOM is ready
  #Awe_Callback_OpenLink        ; called if a new url is called (same as ExtLink and NewLink together)
  #Awe_Callback_OpenExtLink     ; called if a new url is called for a new webview
  #Awe_Callback_OpenNewLink     ; called if a new url is called for the same webview
  #Awe_Callback_BeginLoading    ; called if webview begins to load data
  #Awe_Callback_FinishLoading   ; called if webview has finished loading
  #Awe_Callback_PageContents    ; called if content of a page has finished loading
  #Awe_Callback_TargetChange    ; called if cursor is over a link to display this link
  #Awe_Callback_Tooltip         ; called if tooltip changed under cursor
  #Awe_Callback_Title           ; called if the webview-title has changed
  #Awe_Callback_DownloadFile    ; called if a webview wants to start a download
  #Awe_Callback_Favicon         ; called if a webview has downloaded a new favicon
  ; only need for self drawn on screen (optional)
  #Awe_Callback_FileRequester   ; called if a webview needs the user to choose a file from HDD
  #Awe_Callback_CursorChange    ; called if the cursor should be changed (only for sprite and texture)
  #Awe_Callback_JSDialog        ; called if a JS-Dialog needs to be dispayed (only for sprite and texture)
  ; only need for error-logs
  #Awe_Callback_JSMessage       ; called for a JS messages (error log) 
  #Awe_Callback_Crashed         ; called if the webview has crashed
  #Awe_Callback_PluginCrashed   ; called if a plugin has crashed
  #Awe_Callback_Resource        ; called for every requested resource
  #Awe_Callback_ShowContextMenu ; called if user wants a context menu (right click)
  #Awe_Callback_JSCallback      ; called if a js-object has called a callback-function
EndEnumeration


Structure Awesomium_Request
  *Awe_Request
  Method.s
  Url.s
  Referrer.s
  Headers.s
  Map Element.s()
  Cancle.i   ; set to #True to cancle this request
EndStructure

Structure Awesomium
  Type.i
  StructureUnion
    ID.i
    Gadget.i
    Window.i
    Texture.i
    Sprite.i
  EndStructureUnion
  *WebView
  Url.s
  Loading.i
  TargetUrl.s
  Title.s
  hasFocus.i
  FaviconPath.s
  Favicon.i
  InitResRequest.i
  
  
  ; attributes for window
  Image.i
  hToolTip.i
    
  ;attributes for Sprite3D
  Sprite3D.i
  
  ;attributes for texture and sprite
  Button.i[3]
  RepaintEverything.i
  
  
  ;callbacks
  CB_DomReady.AweP_DomReadyCallback
  CB_BeginLoading.AweP_BeginLoadingCallback
  CB_FinishLoading.AweP_FinishLoadingCallback
  CB_PageContents.AweP_PageContentsCallback
  CB_TargetChange.AweP_TargetChangeCallback
  CB_Favicon.AweP_FaviconCallback
  CB_DownloadFile.AweP_DownloadFileCallback
  CB_OpenExtLink.AweP_OpenExtLinkCallback
  CB_OpenNewLink.AweP_OpenNewLinkCallback
  CB_OpenLink.AweP_OpenLinkCallback
  CB_FileRequester.AweP_FileRequesterCallback
  CB_Title.AweP_TitleCallback
  CB_Tooltip.AweP_TooltipCallback
  CB_JSMessage.AweP_JSMessageCallback
  CB_JSDialog.AweP_JSDialogCallback
  CB_CursorChange.AweP_CursorChangeCallback
  CB_Crashed.AweP_CrashedCallback
  CB_PluginCrashed.AweP_PluginCrashedCallback
  CB_Resource.AweP_ResourceCallback
  CB_ShowContextMenu.AweP_ShowContextMenu
  CB_JSCallback.AweP_JSCallback
  Map CB_ResourceRequest.i(1)
EndStructure
Global NewList Awesomium.Awesomium()
Global NewMap Awe_Mapper.i()
Global NewMap AweWindow_Mapper.i()
Global AwesomiumMutex.i
Global Awesomium_DLL_Path.s

; ----- main -------------------------------------
; #ifdef _WIN32
; _OSMExport bool awe_is_child_process(HINSTANCE hInstance);
; 
; _OSMExport int awe_child_process_main(HINSTANCE hInstance);
; #else
; _OSMExport bool awe_is_child_process(int argc, char** argv);
; 
; _OSMExport int awe_child_process_main(int argc, char** argv);
; #endif
CompilerIf #PB_Compiler_OS = #PB_OS_Windows
  PrototypeC.b awe_is_child_process(hInstance.i)
  PrototypeC.l awe_child_process_main(hInstance.i)
  Macro awe_is_child_process(hInstance)
    (_awe_is_child_process(hInstance) & $FF)
  EndMacro
CompilerElse
  PrototypeC.b awe_is_child_process(argc.l, *argv)
  PrototypeC.l awe_child_process_main(argc.l, *argv)
  Macro awe_is_child_process(argc, argv)
    (_awe_is_child_process(argc, argv) & $FF)
  EndMacro  
CompilerEndIf

; ----- webcore ---------------------------------

; _OSMExport void awe_webcore_initialize_default 	(		)
PrototypeC awe_webcore_initialize_default()

; _OSMExport void awe_webcore_initialize 	(	bool 	enable_plugins, 
; 		bool 	enable_javascript, 
; 		bool 	enable_databases, 
; 		const awe_string * 	package_path, 
; 		const awe_string * 	locale_path, 
; 		const awe_string * 	user_data_path, 
; 		const awe_string * 	plugin_path, 
; 		const awe_string * 	log_path, 
; 		awe_loglevel 	log_level, 
; 		bool 	force_single_process, 
; 		const awe_string * 	child_process_path, 
; 		bool 	enable_auto_detect_encoding, 
; 		const awe_string * 	accept_language_override, 
; 		const awe_string * 	default_charset_override, 
; 		const awe_string * 	user_agent_override, 
; 		const awe_string * 	proxy_server, 
; 		const awe_string * 	proxy_config_script, 
; 		const awe_string * 	auth_server_whitelist, 
; 		bool 	save_cache_and_cookies, 
; 		int 	max_cache_size, 
; 		bool 	disable_same_origin_policy, 
; 		bool 	disable_win_message_pump, 
; 		const awe_string * 	custom_css 
; 	)
PrototypeC awe_webcore_initialize(enable_plugins.b, enable_javascript.b, enable_databases.b, *package_path, *locale_path, *user_data_path, *plugin_path, *log_path, log_level.l, force_single_process.b, *child_process_path, enable_auto_detect_encoding.b,	*accept_language_override, *default_charset_override, *user_agent_override, *proxy_server, *proxy_config_script, *auth_server_whitelist, save_cache_and_cookies.b, max_cache_size.l, disable_same_origin_policy.b, disable_win_message_pump.b, *custom_css)

; _OSMExport void awe_webcore_shutdown 	(		)
PrototypeC awe_webcore_shutdown()

; _OSMExport awe_webview* awe_webcore_create_webview 	(	int 	width, 
; 		int 	height, 
; 		bool 	view_source 
; 	)
PrototypeC.i awe_webcore_create_webview(Width.l, Height.l, viewSource.l)

; _OSMExport void awe_webcore_update 	(		)
PrototypeC awe_webcore_update()

; _OSMExport void awe_webcore_set_base_directory 	(	const awe_string * 	base_dir_path	)
PrototypeC awe_webcore_set_base_directory(*base_dir_path)

; _OSMExport void awe_webcore_set_cookie 	(	const awe_string * 	url, 
; 		const awe_string * 	cookie_string, 
; 		bool 	is_http_only, 
; 		bool 	force_session_cookie 
; 	)
PrototypeC awe_webcore_set_cookie(*url, *cookie_string, is_http_only.b, force_session_cookie.b)

; _OSMExport void awe_webcore_set_custom_response_page 	(	int 	status_code, 
; 		const awe_string * 	file_path 
; 	)
PrototypeC awe_webcore_set_custom_response_page(status_code.l, *file_path)

; _OSMExport void awe_webcore_set_suppress_printer_dialog 	(	bool 	suppress	)
PrototypeC awe_webcore_set_suppress_printer_dialog(suppress.b)

; _OSMExport awe_history_query_result* awe_webcore_query_history 	(	const awe_string * 	full_text_query, 
; 		int 	num_days_ago, 
; 		int 	max_count 
; 	)
PrototypeC.i awe_webcore_query_history(*full_text_query, num_days_ago.l, max_count.l)

; ----- webview ---------------------------------

; _OSMExport void awe_webview_destroy 	(	awe_webview * 	webview	)
PrototypeC awe_webview_destroy(*webview)

; _OSMExport void awe_webview_load_url 	(	awe_webview * 	webview, 
; 		const awe_string * 	url, 
; 		const awe_string * 	frame_name, 
; 		const awe_string * 	username, 
; 		const awe_string * 	password 
; 	)
PrototypeC awe_webview_load_url(*webview, *url, *frame_name, *username, *password)

; _OSMExport void awe_webview_load_file 	(	awe_webview * 	webview, 
; 		const awe_string * 	file, 
; 		const awe_string * 	frame_name 
; 	)
PrototypeC awe_webview_load_file(*webview, *file, *frame_name)

; _OSMExport void awe_webview_load_html 	(	awe_webview * 	webview, 
; 		const awe_string * 	html, 
; 		const awe_string * 	frame_name 
; 	)
PrototypeC awe_webview_load_html(*webview, *html, *frame_name)

; _OSMExport bool awe_webview_is_loading_page 	(	awe_webview * 	webview	)
PrototypeC.b awe_webview_is_loading_page(*webview)
Macro awe_webview_is_loading_page(webview)
  (_awe_webview_is_loading_page(webview) & $FF)
EndMacro

; _OSMExport const awe_renderbuffer* awe_webview_render 	(	awe_webview * 	webview	)
PrototypeC.i awe_webview_render(*webview)

; _OSMExport bool awe_webview_resize 	(	awe_webview * 	webview, 
; 		int 	width, 
; 		int 	height, 
; 		bool 	wait_for_repaint, 
; 		int 	repaint_timeout_ms 
; 	)
PrototypeC.b awe_webview_resize(*webview, width.l, height.l, wait_for_repaint.l, repaint_timeout_ms.l)

; _OSMExport bool awe_webview_is_dirty 	(	awe_webview * 	webview	)
PrototypeC.b awe_webview_is_dirty(*webview)
Macro awe_webview_is_dirty(webview)
  (_awe_webview_is_dirty(webview) & $FF)
EndMacro

; _OSMExport awe_rect awe_webview_get_dirty_bounds 	(	awe_webview * 	webview	)
PrototypeC awe_webview_get_dirty_bounds(*rect, *webview)
Macro awe_webview_get_dirty_bounds(webview, rect)
  _awe_webview_get_dirty_bounds(rect, webview)
EndMacro

; _OSMExport void awe_webview_focus 	(	awe_webview * 	webview	)
PrototypeC awe_webview_focus(*webview)

; _OSMExport void awe_webview_unfocus 	(	awe_webview * 	webview	)
PrototypeC awe_webview_unfocus(*webview)

; _OSMExport void awe_webview_set_transparent 	(	awe_webview * 	webview, 
; 		bool 	is_transparent 
; 	)
PrototypeC awe_webview_set_transparent(*webview, is_transparent.b)

; _OSMExport void awe_webview_choose_file 	(	awe_webview * 	webview, 
; 		const awe_string * 	file_path 
; 	)
PrototypeC awe_webview_choose_file(*webview, *filepath)

; _OSMExport void awe_webview_reload 	(	awe_webview * 	webview	)
PrototypeC awe_webview_reload(*webview)

; _OSMExport awe_string * 	awe_webview_get_url (awe_webview *webview)
PrototypeC.i awe_webview_get_url(*webview)

; _OSMExport void awe_webview_set_zoom 	(	awe_webview * 	webview, 
; 		int 	zoom_percent 
; 	)
PrototypeC awe_webview_set_zoom(*webview, zoom_percent.l)

; _OSMExport void awe_webview_reset_zoom 	(	awe_webview * 	webview	)
PrototypeC awe_webview_reset_zoom(*webview)

; _OSMExport int 	awe_webview_get_zoom (awe_webview *webview)
PrototypeC.l awe_webview_get_zoom(*webview)

; _OSMExport bool awe_webview_is_resizing 	(	awe_webview * 	webview	)
PrototypeC.b awe_webview_is_resizing(*webview)
Macro awe_webview_is_resizing(webview)
  (_awe_webview_is_resizing(webview) & $FF)
EndMacro

; _OSMExport void awe_webview_print 	(	awe_webview * 	webview	)
PrototypeC awe_webview_print(*webview)

; _OSMExport void awe_webview_go_to_history_offset 	(	awe_webview * 	webview, 
; 		int 	offset 
; 	)
PrototypeC awe_webview_go_to_history_offset(*webview, offset.l)

; _OSMExport int 	awe_webview_get_history_back_count (awe_webview *webview)
PrototypeC.l awe_webview_get_history_back_count(*webview)

; _OSMExport int 	awe_webview_get_history_forward_count (awe_webview *webview)
PrototypeC.l awe_webview_get_history_forward_count(*webview)

; ----- javascript ------------------------------

; _OSMExport awe_jsvalue_type 	awe_jsvalue_get_type (const awe_jsvalue *jsvalue)
PrototypeC.l awe_jsvalue_get_type(*jsvalue)

; _OSMExport awe_string* awe_jsvalue_to_string 	(	const awe_jsvalue * 	jsvalue	)
PrototypeC.i awe_jsvalue_to_string(*jsvalue)

; _OSMExport int 	awe_jsvalue_to_integer (const awe_jsvalue *jsvalue)
PrototypeC.i awe_jsvalue_to_integer(*jsvalue)

; _OSMExport double 	awe_jsvalue_to_double (const awe_jsvalue *jsvalue)
PrototypeC.d awe_jsvalue_to_double(*jsvalue)

; _OSMExport const awe_jsarray * 	awe_jsvalue_get_array (const awe_jsvalue *jsvalue)
PrototypeC.i awe_jsvalue_get_array(*jsvalue)

; _OSMExport const awe_jsobject * 	awe_jsvalue_get_object (const awe_jsvalue *jsvalue)
PrototypeC.i awe_jsvalue_get_object(*jsvalue)

; _OSMExport awe_jsarray * 	awe_jsarray_create (const awe_jsvalue **jsvalue_array, size_t length)
PrototypeC.i awe_jsarray_create(*jsvalue_array, length.l)

; _OSMExport void 	awe_jsarray_destroy (awe_jsarray *jsarray)
PrototypeC awe_jsarray_destroy(*jsarray)

; _OSMExport size_t 	awe_jsarray_get_size (const awe_jsarray *jsarray)
PrototypeC.l awe_jsarray_get_size(*jsarray)

; _OSMExport const awe_jsvalue * 	awe_jsarray_get_element (const awe_jsarray *jsarray, size_t index)
PrototypeC.i awe_jsarray_get_element(*jsarray, index.l)

; _OSMExport awe_jsobject * 	awe_jsobject_create ()
PrototypeC.i awe_jsobject_create()

; _OSMExport void 	awe_jsobject_destroy (awe_jsobject *jsobject)
PrototypeC awe_jsobject_destroy(*jsobject)

; _OSMExport bool 	awe_jsobject_has_property (const awe_jsobject *jsobject, const awe_string *property_name)
PrototypeC.b awe_jsobject_has_property(_jsobject_, property_name)
Macro awe_jsobject_has_property(_jsobject_)
  (_awe_jsobject_has_property(_jsobject_, property_name) & $FF)
EndMacro

; _OSMExport const awe_jsvalue * 	awe_jsobject_get_property (const awe_jsobject *jsobject, const awe_string *property_name)
PrototypeC.i awe_jsobject_get_property(*jsobject, *property_name)

; _OSMExport void 	awe_jsobject_set_property (awe_jsobject *jsobject, const awe_string *property_name, const awe_jsvalue *value)
PrototypeC awe_jsobject_set_property(*jsobject, *property_name, *value)

; _OSMExport size_t 	awe_jsobject_get_size (awe_jsobject *jsobject)
PrototypeC.l awe_jsobject_get_size(*jsobject)

; _OSMExport awe_jsarray * 	awe_jsobject_get_keys (awe_jsobject *jsobject)
PrototypeC.i awe_jsobject_get_keys(*jsobject)

; _OSMExport void awe_jsvalue_destroy 	(	awe_jsvalue * 	jsvalue	)
PrototypeC awe_jsvalue_destroy(*jsvalue)

; _OSMExport void awe_webview_create_object 	(	awe_webview * 	webview, 
; 		const awe_string * 	object_name 
; 	)
PrototypeC awe_webview_create_object(*webview, *object_name)

; _OSMExport void awe_webview_destroy_object 	(	awe_webview * 	webview, 
; 		const awe_string * 	object_name 
; 	)
PrototypeC awe_webview_destroy_object(*webview, *object_name)

; _OSMExport void awe_webview_execute_javascript 	(	awe_webview * 	webview, 
; 		const awe_string * 	javascript, 
; 		const awe_string * 	frame_name 
; 	)
PrototypeC awe_webview_execute_javascript(*webview, *javascript, *framen_name)

; _OSMExport awe_jsvalue* awe_webview_execute_javascript_with_result 	(	awe_webview * 	webview, 
; 		const awe_string * 	javascript, 
; 		const awe_string * 	frame_name, 
; 		int 	timeout_ms 
; 	)
PrototypeC.i awe_webview_execute_javascript_with_result(*webview, *javascript, *framename, timeout_ms.l)

; _OSMExport void awe_webview_set_object_callback 	(	awe_webview * 	webview, 
; 		const awe_string * 	object_name, 
; 		const awe_string * 	callback_name 
; 	)
PrototypeC awe_webview_set_object_callback(*webview, *object_name, *callback_name)

; _OSMExport void awe_webview_set_object_property 	(	awe_webview * 	webview, 
; 		const awe_string * 	object_name, 
; 		const awe_string * 	property_name, 
; 		const awe_jsvalue * 	value 
; 	)
PrototypeC awe_webview_set_object_property(*webview, *object_name, *property_name, *value)


; ----- strings ---------------------------------

; _OSMExport const awe_string* awe_string_empty 	(		)
PrototypeC.i awe_string_empty()

; _OSMExport awe_string* awe_string_create_from_utf16 	(	const wchar16 * 	str, 
; 		size_t 	len 
; 	)
PrototypeC.i awe_string_create_from_utf16(str.p-unicode, len.l)

; _OSMExport const wchar16* awe_string_get_utf16 	(	const awe_string * 	str	)
PrototypeC.i awe_string_get_utf16(*str)

; _OSMExport void awe_string_destroy 	(	awe_string * 	str	)
PrototypeC awe_string_destroy(*str)

; _OSMExport size_t awe_string_get_length 	(	const awe_string * 	str	)
PrototypeC.i awe_string_get_length(*str)


; ----- renderbuffer ---------------------------------

; _OSMExport const unsigned char* awe_renderbuffer_get_buffer 	(	const awe_renderbuffer * 	renderbuffer	)
PrototypeC.i awe_renderbuffer_get_buffer(*renderbuffer)

; _OSMExport int awe_renderbuffer_get_height 	(	const awe_renderbuffer * 	renderbuffer	)
PrototypeC.l awe_renderbuffer_get_height(*renderbuffer)

; _OSMExport int awe_renderbuffer_get_width 	(	const awe_renderbuffer * 	renderbuffer	)
PrototypeC.l awe_renderbuffer_get_width(*renderbuffer)

; _OSMExport bool awe_renderbuffer_save_to_png 	(	const awe_renderbuffer * 	renderbuffer, 
; 		const awe_string * 	file_path, 
; 		bool 	preserve_transparency 
; 	)
PrototypeC.b awe_renderbuffer_save_to_png(*renderbuffer, *file_path, preserve_transparency)
Macro awe_renderbuffer_save_to_png(renderbuffe, file_path, preserve_transparency)
  (_awe_renderbuffer_save_to_png(renderbuffe, file_path, preserve_transparency) & $FF)
EndMacro


; ----- injection ---------------------------------

; _OSMExport void awe_webview_inject_mouse_move 	(	awe_webview * 	webview, 
; 		int 	x, 
; 		int 	y 
; 	)
PrototypeC awe_webview_inject_mouse_move(*webview, x.l, y.l)

; _OSMExport void awe_webview_inject_mouse_down 	(	awe_webview * 	webview, 
; 		awe_mousebutton 	button 
; 	)
PrototypeC awe_webview_inject_mouse_down(*webview, button.l)

; _OSMExport void awe_webview_inject_mouse_up 	(	awe_webview * 	webview, 
; 		awe_mousebutton 	button 
; 	)
PrototypeC awe_webview_inject_mouse_up(*webview, button.l)

; _OSMExport void awe_webview_inject_mouse_wheel 	(	awe_webview * 	webview, 
; 		int 	scroll_amount_vert, 
; 		int 	scroll_amount_horz 
; 	)
PrototypeC awe_webview_inject_mouse_wheel(*webview, scroll_amount_vert.l, scroll_amount_horz.l)

; _OSMExport void awe_webview_inject_keyboard_event 	(	awe_webview * 	webview, 
; 		awe_webkeyboardevent 	key_event 
; 	)
PrototypeC awe_webview_inject_keyboard_event(*webview,  type.l, modifiers.l, virtual_key_code.l, native_key_code.l, text.q, unmodified_Text.q, is_system_key.l)
Macro awe_webview_inject_keyboard_event(webview, key_event)
  _awe_webview_inject_keyboard_event(webview, key_event\type, key_event\modifiers, key_event\virtual_key_code, key_event\native_key_code, PeekQ(key_event + OffsetOf(awe_webkeyboardevent\text)), PeekQ(key_event + OffsetOf(awe_webkeyboardevent\unmodified_Text)), key_event\is_system_key)
EndMacro

; _OSMExport void awe_webview_inject_keyboard_event_win(awe_webview* webview,
; 													  UINT msg,
; 													  WPARAM wparam,
; 													  LPARAM lparam);
PrototypeC awe_webview_inject_keyboard_event_win(*webview, msg.i, wparam.l, lparam.l)


; ----- resource --------------------------------

; _OSMExport awe_resource_response * awe_resource_response_create (size_t num_bytes, unsigned char *buffer, const awe_string *mime_type)
PrototypeC.i awe_resource_response_create(num_bytes.l, *buffer, *mime_type)

; _OSMExport awe_resource_response * 	awe_resource_response_create_from_file (const awe_string *file_path)
PrototypeC.i awe_resource_response_create_from_file(*file_path)

; _OSMExport void 	awe_resource_request_cancel (awe_resource_request *request)
PrototypeC awe_resource_request_cancel(*request)

; _OSMExport awe_string * 	awe_resource_request_get_url (awe_resource_request *request)
PrototypeC.i awe_resource_request_get_url(*request)

; _OSMExport awe_string * 	awe_resource_request_get_method (awe_resource_request *request)
PrototypeC.i awe_resource_request_get_method(*request)

; _OSMExport void 	awe_resource_request_set_method (awe_resource_request *request, const awe_string *method)
PrototypeC awe_resource_request_set_method(*request, *method)

; _OSMExport awe_string * 	awe_resource_request_get_referrer (awe_resource_request *request)
PrototypeC.i awe_resource_request_get_referrer(*request)

; _OSMExport void 	awe_resource_request_set_referrer (awe_resource_request *request, const awe_string *referrer)
PrototypeC awe_resource_request_set_referrer(*request, *referrer)

; _OSMExport awe_string * 	awe_resource_request_get_extra_headers (awe_resource_request *request)
PrototypeC.i awe_resource_request_get_extra_headers(*request)

; _OSMExport void 	awe_resource_request_set_extra_headers (awe_resource_request *request, const awe_string *headers)
PrototypeC awe_resource_request_set_extra_headers(*request, *headers)

; _OSMExport void 	awe_resource_request_append_extra_header (awe_resource_request *request, const awe_string *name, const awe_string *value)
PrototypeC awe_resource_request_append_extra_header(*request, *name, *value)

; _OSMExport size_t 	awe_resource_request_get_num_upload_elements (awe_resource_request *request)
PrototypeC.l awe_resource_request_get_num_upload_elements(*request)

; _OSMExport const awe_upload_element * 	awe_resource_request_get_upload_element (awe_resource_request *request, size_t idx)
PrototypeC.i awe_resource_request_get_upload_element(*request, idx.l)

; _OSMExport void 	awe_resource_request_clear_upload_elements (awe_resource_request *request)
PrototypeC awe_resource_request_clear_upload_elements(*request)

; _OSMExport void 	awe_resource_request_append_upload_file_path (awe_resource_request *request, const awe_string *file_path)
PrototypeC awe_resource_request_append_upload_file_path(*request, *file_path)

; _OSMExport void 	awe_resource_request_append_upload_bytes (awe_resource_request *request, const awe_string *bytes)
PrototypeC awe_resource_request_append_upload_bytes(*request, *bytes)

; _OSMExport bool 	awe_upload_element_is_file_path (const awe_upload_element *ele)
PrototypeC.b awe_upload_element_is_file_path(*ele)
Macro awe_upload_element_is_file_path(ele)
  (_awe_upload_element_is_file_path(ele) & $FF)
EndMacro

; _OSMExport bool 	awe_upload_element_is_bytes (const awe_upload_element *ele)
PrototypeC.b awe_upload_element_is_bytes(*ele)
Macro awe_upload_element_is_bytes(ele)
  (_awe_upload_element_is_bytes(ele) & $FF)
EndMacro

; _OSMExport awe_string * 	awe_upload_element_get_bytes (const awe_upload_element *ele)
PrototypeC.i awe_upload_element_get_bytes(*ele)

; _OSMExport awe_string * 	awe_upload_element_get_file_path (const awe_upload_element *ele)
PrototypeC.i awe_upload_element_get_file_path(*ele)


; ----- history ---------------------------------

; _OSMExport awe_history_entry* awe_history_query_result_get_entry_at_index 	(	awe_history_query_result * 	res, 
; 		size_t 	idx 
; 	)
PrototypeC.i awe_history_query_result_get_entry_at_index(*res, idx.l)

; _OSMExport void 	awe_history_query_result_destroy (awe_history_query_result *res)
PrototypeC awe_history_query_result_destroy(*res)

; _OSMExport size_t 	awe_history_query_result_get_size (awe_history_query_result *res)
PrototypeC.l awe_history_query_result_get_size(*res)

; _OSMExport void 	awe_history_entry_destroy (awe_history_entry *entry)
PrototypeC awe_history_entry_destroy(*entry)

; _OSMExport awe_string * 	awe_history_entry_get_url (awe_history_entry *entry)
PrototypeC.i awe_history_entry_get_url(*entry)

; _OSMExport awe_string * 	awe_history_entry_get_title (awe_history_entry *entry)
PrototypeC.i awe_history_entry_get_title(*entry)

; _OSMExport double 	awe_history_entry_get_visit_time (awe_history_entry *entry)
PrototypeC.d awe_history_entry_get_visit_time(*entry)

; _OSMExport int 	awe_history_entry_get_visit_count (awe_history_entry *entry)
PrototypeC.l awe_history_entry_get_visit_count(*entry)


; ----- callback ---------------------------------

; _OSMExport void awe_webview_set_callback_change_cursor 	(	awe_webview * 	webview, 
; 		void(*)(awe_webview *caller, awe_cursor_type cursor) 	callback 
; 	)
PrototypeC awe_webview_set_callback_change_cursor(*webview, *callback)

; _OSMExport void awe_webview_set_callback_open_external_link 	(	awe_webview * 	webview, 
; 		void(*)(awe_webview *caller, const awe_string *url, const awe_string *source) 	callback 
; 	)
PrototypeC awe_webview_set_callback_open_external_link(*webview, *callback)

; _OSMExport void awe_webview_set_callback_change_target_url 	(	awe_webview * 	webview, 
; 		void(*)(awe_webview *caller, const awe_string *url) 	callback 
; 	)
PrototypeC awe_webview_set_callback_change_target_url(*webview, *callback)

; _OSMExport void awe_webview_set_callback_begin_navigation 	(	awe_webview * 	webview, 
; 		void(*)(awe_webview *caller, const awe_string *url, const awe_string *frame_name) 	callback 
; 	)
PrototypeC awe_webview_set_callback_begin_navigation(*webview, *callback)

; _OSMExport void awe_webview_set_callback_request_download 	(	awe_webview * 	webview, 
; 		void(*)(awe_webview *caller, const awe_string *download) 	callback 
; 	)
PrototypeC awe_webview_set_callback_request_download(*webview, *callback)

; _OSMExport void awe_webview_set_callback_dom_ready 	(	awe_webview * 	webview, 
; 		void(*)(awe_webview *caller) 	callback 
; 	)
PrototypeC awe_webview_set_callback_dom_ready(*webview, *callback)

; _OSMExport void awe_webview_set_callback_begin_loading 	(	awe_webview * 	webview, 
; 		void(*)(awe_webview *caller, const awe_string *url, const awe_string *frame_name, int status_code, const awe_string *mime_type) 	callback 
; 	)
PrototypeC awe_webview_set_callback_begin_loading(*webview, *callback)

; _OSMExport void awe_webview_set_callback_finish_loading 	(	awe_webview * 	webview, 
; 		void(*)(awe_webview *caller) 	callback 
; 	)
PrototypeC awe_webview_set_callback_finish_loading(*webview, *callback)

; 	_OSMExport void awe_webview_set_callback_get_page_contents 	(	awe_webview * 	webview, 
; 		void(*)(awe_webview *caller, const awe_string *url, const awe_string *contents) 	callback 
; 	)
PrototypeC awe_webview_set_callback_get_page_contents(*webview, *callback)

; _OSMExport void awe_webview_set_callback_change_tooltip 	(	awe_webview * 	webview, 
; 		void(*)(awe_webview *caller, const awe_string *tooltip) 	callback 
; 	)
PrototypeC awe_webview_set_callback_change_tooltip(*webview, *callback)

; _OSMExport void awe_webview_set_callback_receive_title 	(	awe_webview * 	webview, 
; 		void(*)(awe_webview *caller, const awe_string *title, const awe_string *frame_name) 	callback 
; 	)
PrototypeC awe_webview_set_callback_receive_title(*webview, *callback)

; _OSMExport void awe_webview_set_callback_request_file_chooser 	(	awe_webview * 	webview, 
; 		void(*)(awe_webview *caller, bool select_multiple_files, const awe_string *title, const awe_string *default_path) 	callback 
; 	)
PrototypeC awe_webview_set_callback_request_file_chooser(*webview, *calback)

; _OSMExport void awe_webview_set_callback_js_callback 	(	awe_webview * 	webview, 
; 		void(*)(awe_webview *caller, const awe_string *object_name, const awe_string *callback_name, const awe_jsarray *arguments) 	callback 
; 	)
PrototypeC awe_webview_set_callback_js_callback(*webview, *callback)

; _OSMExport void awe_webview_set_callback_js_console_message 	(	awe_webview * 	webview, 
; 		void(*)(awe_webview *caller, const awe_string *message, int line_number, const awe_string *source) 	callback 
; 	)
PrototypeC awe_webview_set_callback_js_console_message(*webview, *callback)

; _OSMExport void awe_webview_set_callback_show_javascript_dialog 	(	awe_webview * 	webview, 
; 		void(*)(awe_webview *caller, int request_id, int dialog_flags, const awe_string *message, const awe_string *default_prompt, const awe_string *frame_url) 	callback 
; 	)
PrototypeC awe_webview_set_callback_show_javascript_dialog(*webview, *callback)

; _OSMExport void awe_webview_set_callback_web_view_crashed 	(	awe_webview * 	webview, 
; 		void(*)(awe_webview *caller) 	callback 
; 	)
PrototypeC awe_webview_set_callback_web_view_crashed(*webview, *callback)

; _OSMExport void awe_webview_set_callback_plugin_crashed 	(	awe_webview * 	webview, 
; 		void(*)(awe_webview *caller, const awe_string *plugin_name) 	callback 
; 	)
PrototypeC awe_webview_set_callback_plugin_crashed(*webview, *callback)

; _OSMExport void awe_webview_set_callback_resource_response 	(	awe_webview * 	webview, 
; 		void(*)(awe_webview *caller, const awe_string *url, int status_code, bool was_cached, int64 request_time_ms, int64 response_time_ms, int64 expected_content_size, const awe_string *mime_type) 	callback 
; 	)
PrototypeC awe_webview_set_callback_resource_response(*webview, *callback)

; _OSMExport void awe_webview_set_callback_finish_resize 	(	awe_webview * 	webview, 
; 		void(*)(awe_webview *caller, int width, int height) 	callback 
; 	)
PrototypeC awe_webview_set_callback_finish_resize(*webview, *callback)


; _OSMExport void awe_webview_set_callback_show_context_menu 	(	awe_webview * 	webview, 
; 		void(*)(awe_webview *caller, int mouse_x, int mouse_y, awe_media_type type, int media_state, const awe_string *link_url, const awe_string *src_url, const awe_string *page_url, const awe_string *frame_url, const awe_string *selection_text, bool is_editable, int edit_flags) 	callback 
; 	)
PrototypeC awe_webview_set_callback_show_context_menu(*webview, *callback)

; _OSMExport void awe_webview_set_callback_resource_request 	(	awe_webview * 	webview, 
; 		awe_resource_response *(*)(awe_webview *caller, awe_resource_request *request) 	callback 
; 	)
PrototypeC awe_webview_set_callback_resource_request(*webview, *callback)

; _OSMExport void awe_webview_set_callback_change_history 	(	awe_webview * 	webview, 
; 		void(*)(awe_webview *caller, int back_count, int forward_count) 	callback 
; 	)
PrototypeC awe_webview_set_callback_change_history(*webiview, *callback)


Declare.i SelectAwesomium(ID.i)



Procedure InitAwesomium(Path.s, UserAgent.s, Javascript.i = #True, BaseDir.s="", ChildProcessPath.s="self", CustomCSS.s = "", CacheSize.i = 0, SameOriginPolicy = #True, Language.s = "")
  Protected Lib.i = OpenLibrary(#PB_Any, Path)
  Awesomium_DLL_Path = GetPathPart(Path)
  
  If Lib
    Global _awe_is_child_process.awe_is_child_process = GetFunction(Lib, "awe_is_child_process")
    Global awe_child_process_main.awe_child_process_main = GetFunction(Lib, "awe_child_process_main")
    Global awe_webcore_initialize_default.awe_webcore_initialize_default = GetFunction(Lib, "awe_webcore_initialize_default")
    Global awe_webcore_initialize.awe_webcore_initialize = GetFunction(Lib, "awe_webcore_initialize")
    Global awe_webcore_shutdown.awe_webcore_shutdown = GetFunction(Lib, "awe_webcore_shutdown")
    Global awe_webview_destroy.awe_webview_destroy = GetFunction(Lib, "awe_webview_destroy")
    Global awe_webcore_create_webview.awe_webcore_create_webview = GetFunction(Lib, "awe_webcore_create_webview")
    Global awe_webview_load_url.awe_webview_load_url = GetFunction(Lib, "awe_webview_load_url")
    Global awe_webview_load_file.awe_webview_load_file = GetFunction(Lib, "awe_webview_load_file")
    Global awe_webview_load_html.awe_webview_load_html = GetFunction(Lib, "awe_webview_load_html")
    Global _awe_webview_is_loading_page.awe_webview_is_loading_page = GetFunction(Lib, "awe_webview_is_loading_page")
    Global awe_webview_focus.awe_webview_focus = GetFunction(Lib, "awe_webview_focus")
    Global awe_webview_unfocus.awe_webview_unfocus = GetFunction(Lib, "awe_webview_unfocus")
    Global awe_webcore_update.awe_webcore_update = GetFunction(Lib, "awe_webcore_update")
    Global awe_webcore_set_suppress_printer_dialog.awe_webcore_set_suppress_printer_dialog = GetFunction(Lib, "awe_webcore_set_suppress_printer_dialog")
    Global awe_webcore_set_base_directory.awe_webcore_set_base_directory = GetFunction(Lib, "awe_webcore_set_base_directory")
    Global awe_webcore_set_cookie.awe_webcore_set_cookie = GetFunction(Lib, "awe_webcore_set_cookie")
    Global awe_webcore_set_custom_response_page.awe_webcore_set_custom_response_page = GetFunction(Lib, "awe_webcore_set_custom_response_page")
    Global awe_webcore_query_history.awe_webcore_query_history = GetFunction(Lib, "awe_webcore_query_history")
    Global awe_string_empty.awe_string_empty = GetFunction(Lib, "awe_string_empty")
    Global awe_string_create_from_utf16.awe_string_create_from_utf16 = GetFunction(Lib, "awe_string_create_from_utf16")
    Global awe_string_get_utf16.awe_string_get_utf16 = GetFunction(Lib, "awe_string_get_utf16")
    Global awe_string_destroy.awe_string_destroy = GetFunction(Lib, "awe_string_destroy")
    Global awe_string_get_length.awe_string_get_length = GetFunction(Lib, "awe_string_get_length")
    Global awe_webview_render.awe_webview_render = GetFunction(Lib, "awe_webview_render")
    Global awe_renderbuffer_save_to_png.awe_renderbuffer_save_to_png = GetFunction(Lib, "awe_renderbuffer_save_to_png")
    Global _awe_webview_is_dirty.awe_webview_is_dirty = GetFunction(Lib, "awe_webview_is_dirty")
    Global _awe_webview_get_dirty_bounds.awe_webview_get_dirty_bounds = GetFunction(Lib, "awe_webview_get_dirty_bounds")
    Global awe_webview_set_transparent.awe_webview_set_transparent = GetFunction(Lib, "awe_webview_set_transparent")
    Global awe_webview_get_url.awe_webview_get_url = GetFunction(Lib, "awe_webview_get_url")
    Global awe_webview_set_zoom.awe_webview_set_zoom = GetFunction(Lib, "awe_webview_set_zoom")
    Global awe_webview_reset_zoom.awe_webview_reset_zoom = GetFunction(Lib, "awe_webview_reset_zoom")
    Global awe_webview_get_zoom.awe_webview_get_zoom = GetFunction(Lib, "awe_webview_get_zoom")
    Global _awe_webview_is_resizing.awe_webview_is_resizing = GetFunction(Lib, "awe_webview_is_resizing")
    Global awe_webview_create_object.awe_webview_create_object = GetFunction(Lib, "awe_webview_create_object")
    Global awe_webview_destroy_object.awe_webview_destroy_object = GetFunction(Lib, "awe_webview_destroy_object")
    Global awe_webview_execute_javascript.awe_webview_execute_javascript = GetFunction(Lib, "awe_webview_execute_javascript")
    Global awe_webview_execute_javascript_with_result.awe_webview_execute_javascript_with_result = GetFunction(Lib, "awe_webview_execute_javascript_with_result")
    Global awe_webview_set_object_callback.awe_webview_set_object_callback = GetFunction(Lib, "awe_webview_set_object_callback")
    Global awe_webview_set_object_property.awe_webview_set_object_property = GetFunction(Lib, "awe_webview_set_object_property")
    Global awe_renderbuffer_get_buffer.awe_renderbuffer_get_buffer = GetFunction(Lib, "awe_renderbuffer_get_buffer")
    Global awe_renderbuffer_get_height.awe_renderbuffer_get_height = GetFunction(Lib, "awe_renderbuffer_get_height")
    Global awe_renderbuffer_get_width.awe_renderbuffer_get_width = GetFunction(Lib, "awe_renderbuffer_get_width")
    Global awe_resource_response_create.awe_resource_response_create = GetFunction(Lib, "awe_resource_response_create")
    Global awe_resource_response_create_from_file.awe_resource_response_create_from_file = GetFunction(Lib, "awe_resource_response_create_from_file")
    Global awe_resource_request_cancel.awe_resource_request_cancel = GetFunction(Lib, "awe_resource_request_cancel")
    Global awe_resource_request_get_url.awe_resource_request_get_url = GetFunction(Lib, "awe_resource_request_get_url")
    Global awe_resource_request_get_method.awe_resource_request_get_method = GetFunction(Lib, "awe_resource_request_get_method")
    Global awe_resource_request_set_method.awe_resource_request_set_method = GetFunction(Lib, "awe_resource_request_set_method")
    Global awe_resource_request_get_referrer.awe_resource_request_get_referrer = GetFunction(Lib, "awe_resource_request_get_referrer")
    Global awe_resource_request_set_referrer.awe_resource_request_set_referrer = GetFunction(Lib, "awe_resource_request_set_referrer")
    Global awe_resource_request_get_extra_headers.awe_resource_request_get_extra_headers = GetFunction(Lib, "awe_resource_request_get_extra_headers")
    Global awe_resource_request_set_extra_headers.awe_resource_request_set_extra_headers = GetFunction(Lib, "awe_resource_request_set_extra_headers")
    Global awe_resource_request_append_extra_header.awe_resource_request_append_extra_header = GetFunction(Lib, "awe_resource_request_append_extra_header")
    Global awe_resource_request_get_num_upload_elements.awe_resource_request_get_num_upload_elements = GetFunction(Lib, "awe_resource_request_get_num_upload_elements")
    Global awe_resource_request_get_upload_element.awe_resource_request_get_upload_element = GetFunction(Lib, "awe_resource_request_get_upload_element")
    Global awe_resource_request_clear_upload_elements.awe_resource_request_clear_upload_elements = GetFunction(Lib, "awe_resource_request_clear_upload_elements")
    Global awe_resource_request_append_upload_file_path.awe_resource_request_append_upload_file_path = GetFunction(Lib, "awe_resource_request_append_upload_file_path")
    Global awe_resource_request_append_upload_bytes.awe_resource_request_append_upload_bytes = GetFunction(Lib, "awe_resource_request_append_upload_bytes")
    Global _awe_upload_element_is_file_path.awe_upload_element_is_file_path = GetFunction(Lib, "awe_upload_element_is_file_path")
    Global _awe_upload_element_is_bytes.awe_upload_element_is_bytes = GetFunction(Lib, "awe_upload_element_is_bytes")
    Global awe_upload_element_get_bytes.awe_upload_element_get_bytes = GetFunction(Lib, "awe_upload_element_get_bytes")
    Global awe_upload_element_get_file_path.awe_upload_element_get_file_path = GetFunction(Lib, "awe_upload_element_get_file_path")
    Global awe_webview_inject_mouse_move.awe_webview_inject_mouse_move = GetFunction(Lib, "awe_webview_inject_mouse_move")
    Global awe_webview_inject_mouse_down.awe_webview_inject_mouse_down = GetFunction(Lib, "awe_webview_inject_mouse_down")
    Global awe_webview_inject_mouse_up.awe_webview_inject_mouse_up = GetFunction(Lib, "awe_webview_inject_mouse_up")
    Global awe_webview_inject_mouse_wheel.awe_webview_inject_mouse_wheel = GetFunction(Lib, "awe_webview_inject_mouse_wheel")
    Global _awe_webview_inject_keyboard_event.awe_webview_inject_keyboard_event = GetFunction(Lib, "awe_webview_inject_keyboard_event")
    Global awe_webview_set_callback_change_cursor.awe_webview_set_callback_change_cursor = GetFunction(Lib, "awe_webview_set_callback_change_cursor")
    Global awe_webview_resize.awe_webview_resize = GetFunction(Lib, "awe_webview_resize")
    Global awe_jsvalue_get_type.awe_jsvalue_get_type = GetFunction(Lib, "awe_jsvalue_get_type")
    Global awe_jsvalue_to_string.awe_jsvalue_to_string = GetFunction(Lib, "awe_jsvalue_to_string")
    Global awe_jsvalue_to_integer.awe_jsvalue_to_integer = GetFunction(Lib, "awe_jsvalue_to_integer")
    Global awe_jsvalue_to_double.awe_jsvalue_to_double = GetFunction(Lib, "awe_jsvalue_to_double")
    Global awe_jsvalue_get_array.awe_jsvalue_get_array = GetFunction(Lib, "awe_jsvalue_get_array")
    Global awe_jsvalue_get_object.awe_jsvalue_get_object = GetFunction(Lib, "awe_jsvalue_get_object")
    Global awe_jsarray_create.awe_jsarray_create = GetFunction(Lib, "awe_jsarray_create")
    Global awe_jsarray_destroy.awe_jsarray_destroy = GetFunction(Lib, "awe_jsarray_destroy")
    Global awe_jsarray_get_size.awe_jsarray_get_size = GetFunction(Lib, "awe_jsarray_get_size")
    Global awe_jsarray_get_element.awe_jsarray_get_element = GetFunction(Lib, "awe_jsarray_get_element")
    Global awe_jsobject_create.awe_jsobject_create = GetFunction(Lib, "awe_jsobject_create")
    Global awe_jsobject_destroy.awe_jsobject_destroy = GetFunction(Lib, "awe_jsobject_destroy")
    Global _awe_jsobject_has_property.awe_jsobject_has_property = GetFunction(Lib, "awe_jsobject_has_property")
    Global awe_jsobject_get_property.awe_jsobject_get_property = GetFunction(Lib, "awe_jsobject_get_property")
    Global awe_jsobject_set_property.awe_jsobject_set_property = GetFunction(Lib, "awe_jsobject_set_property")
    Global awe_jsobject_get_size.awe_jsobject_get_size = GetFunction(Lib, "awe_jsobject_get_size")
    Global awe_jsobject_get_keys.awe_jsobject_get_keys = GetFunction(Lib, "awe_jsobject_get_keys")
    Global awe_jsvalue_destroy.awe_jsvalue_destroy = GetFunction(Lib, "awe_jsvalue_destroy")
    Global awe_webview_go_to_history_offset.awe_webview_go_to_history_offset = GetFunction(Lib, "awe_webview_go_to_history_offset")
    Global awe_webview_get_history_back_count.awe_webview_get_history_back_count = GetFunction(Lib, "awe_webview_get_history_back_count")
    Global awe_webview_get_history_forward_count.awe_webview_get_history_forward_count = GetFunction(Lib, "awe_webview_get_history_forward_count")
    Global awe_history_query_result_destroy.awe_history_query_result_destroy = GetFunction(Lib, "awe_history_query_result_destroy")
    Global awe_history_query_result_get_size.awe_history_query_result_get_size = GetFunction(Lib, "awe_history_query_result_get_size")
    Global awe_history_query_result_get_entry_at_index.awe_history_query_result_get_entry_at_index = GetFunction(Lib, "awe_history_query_result_get_entry_at_index")
    Global awe_history_entry_destroy.awe_history_entry_destroy = GetFunction(Lib, "awe_history_entry_destroy")
    Global awe_history_entry_get_url.awe_history_entry_get_url = GetFunction(Lib, "awe_history_entry_get_url")
    Global awe_history_entry_get_title.awe_history_entry_get_title = GetFunction(Lib, "awe_history_entry_get_title")
    Global awe_history_entry_get_visit_time.awe_history_entry_get_visit_time = GetFunction(Lib, "awe_history_entry_get_visit_time")
    Global awe_history_entry_get_visit_count.awe_history_entry_get_visit_count = GetFunction(Lib, "awe_history_entry_get_visit_count")
    Global awe_webview_set_callback_open_external_link.awe_webview_set_callback_open_external_link = GetFunction(Lib, "awe_webview_set_callback_open_external_link")
    Global awe_webview_set_callback_change_target_url.awe_webview_set_callback_change_target_url = GetFunction(Lib, "awe_webview_set_callback_change_target_url")
    Global awe_webview_set_callback_begin_navigation.awe_webview_set_callback_begin_navigation = GetFunction(Lib, "awe_webview_set_callback_begin_navigation")
    Global awe_webview_set_callback_request_download.awe_webview_set_callback_request_download = GetFunction(Lib, "awe_webview_set_callback_request_download")
    Global awe_webview_set_callback_begin_loading.awe_webview_set_callback_begin_loading = GetFunction(Lib, "awe_webview_set_callback_begin_loading")
    Global awe_webview_set_callback_finish_loading.awe_webview_set_callback_finish_loading = GetFunction(Lib, "awe_webview_set_callback_finish_loading")
    Global awe_webview_set_callback_get_page_contents.awe_webview_set_callback_get_page_contents = GetFunction(Lib, "awe_webview_set_callback_get_page_contents")
    Global awe_webview_set_callback_change_tooltip.awe_webview_set_callback_change_tooltip = GetFunction(Lib, "awe_webview_set_callback_change_tooltip")
    Global awe_webview_inject_keyboard_event_win.awe_webview_inject_keyboard_event_win = GetFunction(Lib, "awe_webview_inject_keyboard_event_win")
    Global awe_webview_set_callback_receive_title.awe_webview_set_callback_receive_title = GetFunction(Lib, "awe_webview_set_callback_receive_title")
    Global awe_webview_set_callback_request_file_chooser.awe_webview_set_callback_request_file_chooser = GetFunction(Lib, "awe_webview_set_callback_request_file_chooser")
    Global awe_webview_choose_file.awe_webview_choose_file = GetFunction(Lib, "awe_webview_choose_file")
    Global awe_webview_reload.awe_webview_reload = GetFunction(Lib, "awe_webview_reload")
    Global awe_webview_set_callback_dom_ready.awe_webview_set_callback_dom_ready = GetFunction(Lib, "awe_webview_set_callback_dom_ready")
    Global awe_webview_set_callback_js_callback.awe_webview_set_callback_js_callback = GetFunction(Lib, "awe_webview_set_callback_js_callback")
    Global awe_webview_set_callback_js_console_message.awe_webview_set_callback_js_console_message = GetFunction(Lib, "awe_webview_set_callback_js_console_message")
    Global awe_webview_set_callback_show_javascript_dialog.awe_webview_set_callback_show_javascript_dialog = GetFunction(Lib, "awe_webview_set_callback_show_javascript_dialog")
    Global awe_webview_set_callback_web_view_crashed.awe_webview_set_callback_web_view_crashed = GetFunction(Lib, "awe_webview_set_callback_web_view_crashed")
    Global awe_webview_set_callback_plugin_crashed.awe_webview_set_callback_plugin_crashed = GetFunction(Lib, "awe_webview_set_callback_plugin_crashed")
    Global awe_webview_set_callback_resource_response.awe_webview_set_callback_resource_response = GetFunction(Lib, "awe_webview_set_callback_resource_response")
    Global awe_webview_set_callback_finish_resize.awe_webview_set_callback_finish_resize = GetFunction(Lib, "awe_webview_set_callback_finish_resize")
    Global awe_webview_set_callback_show_context_menu.awe_webview_set_callback_show_context_menu = GetFunction(Lib, "awe_webview_set_callback_show_context_menu")
    Global awe_webview_set_callback_resource_request.awe_webview_set_callback_resource_request = GetFunction(Lib, "awe_webview_set_callback_resource_request")
    
;     ExamineLibraryFunctions(Lib)
;     While NextLibraryFunction()
;       Debug LibraryFunctionName()
;     Wend


    ; has the effect that all childprocesses are named like
    ; the mainprocess instead of AwesomiumProcess.exe
    CompilerIf #PB_Compiler_OS = #PB_OS_Windows
      If awe_is_child_process(GetModuleHandle_(0)) 
        SetCurrentDirectory(Awesomium_DLL_Path)
        awe_child_process_main(GetModuleHandle_(0))
        End
      EndIf
      If ChildProcessPath
        If OSVersion() < #PB_OS_Windows_Vista
          ; feature doesn't work on older windows
          ChildProcessPath = ""
        EndIf
      EndIf
    CompilerElse
      Debug "awe_is_child_process()-call missing"
      Debug "don't know how to get right parameter for awe_child_process_main(),"
      Debug "so i have to deactivate this feature. Please improve this!"
      ChildProcessPath = ""  
    CompilerEndIf
    ; --------
    
    ; init
    Protected enable_plugins.b, enable_javascript.b, enable_databases.b, *package_path, *locale_path, *user_data_path, *plugin_path, *log_path, log_level.l, force_single_process.b, *child_process_path, enable_auto_detect_encoding.b,	*accept_language_override, *default_charset_override, *user_agent_override, *proxy_server, *proxy_config_script, *auth_server_whitelist, save_cache_and_cookies.b, max_cache_size.l, disable_same_origin_policy.b, disable_win_message_pump.b, *custom_css
    enable_plugins = #False
    enable_javascript = Javascript
    enable_databases = #False
    *package_path = awe_string_empty()
    *locale_path = awe_string_empty()
    *user_data_path = awe_string_empty()
    *plugin_path = awe_string_empty()
    *log_path = awe_string_empty()
    log_level = #AWE_LL_NONE
    force_single_process = #False
    If ChildProcessPath
      *child_process_path = awe_string_create_from_utf16(ChildProcessPath, Len(ChildProcessPath))
    Else
      *child_process_path = awe_string_empty()
    EndIf
    enable_auto_detect_encoding = #True
    If Language
      *accept_language_override = awe_string_create_from_utf16(Language, Len(Language))
    Else
      *accept_language_override = awe_string_empty()
    EndIf
    *default_charset_override = awe_string_empty()
    If UserAgent
      *user_agent_override = awe_string_create_from_utf16(UserAgent, Len(UserAgent))
    Else
      *user_agent_override = awe_string_empty()
    EndIf
    *proxy_server = awe_string_empty()
    *proxy_config_script = awe_string_empty()
    *auth_server_whitelist = awe_string_empty()
    save_cache_and_cookies = #False
    max_cache_size = CacheSize
    If SameOriginPolicy
      disable_same_origin_policy = #False
    Else
      disable_same_origin_policy = #True
    EndIf
    disable_win_message_pump = #True ;disabled because PB manages window-events at his own
    If CustomCSS
      *custom_css = awe_string_create_from_utf16(CustomCSS, Len(CustomCSS))
    Else
      *custom_css = awe_string_empty()
    EndIf
    awe_webcore_initialize(enable_plugins, enable_javascript, enable_databases, *package_path, *locale_path, *user_data_path, *plugin_path, *log_path, log_level, force_single_process, *child_process_path, enable_auto_detect_encoding,	*accept_language_override, *default_charset_override, *user_agent_override, *proxy_server, *proxy_config_script, *auth_server_whitelist, save_cache_and_cookies, max_cache_size, disable_same_origin_policy, disable_win_message_pump, *custom_css)
    If ChildProcessPath : awe_string_destroy(*child_process_path) : EndIf
    If Language  : awe_string_destroy(*accept_language_override) : EndIf
    If UserAgent : awe_string_destroy(*user_agent_override) : EndIf
    If CustomCSS : awe_string_destroy(*custom_css) : EndIf
    ; ----
    
    
    If BaseDir
      *locale_path = awe_string_create_from_utf16(BaseDir, Len(BaseDir))
      awe_webcore_set_base_directory(*locale_path)
      awe_string_destroy(*locale_path)
    EndIf
    
    ;used for Favicon!
    InitNetwork()
    
    AwesomiumMutex = CreateMutex()
  EndIf
  
  ProcedureReturn Lib
EndProcedure

Procedure.s awe_string_get_string(*str)
  Protected len.i = awe_string_get_length(*str)
  *str = awe_string_get_utf16(*str)
  ProcedureReturn PeekS(*str, len, #PB_Unicode)
EndProcedure


; --------------------------------------------------------------
;- 
;- > Internal Functions < <
;
; --------------------------------------------------------------

; #PB_PixelFormat_32Bits_BGR | #PB_PixelFormat_ReversedY
Procedure Awe_RedrawAwesomium_BGR32Y(*Awesomium.Awesomium)
  Protected *RenderBuffer, *srcBuffer, *destBuffer
  Protected rect.awe_rect
  Protected y.i, Size.i, BufferPitch.i
  
  awe_webview_get_dirty_bounds(*Awesomium\WebView, @rect)
  *RenderBuffer = awe_webview_render(*Awesomium\WebView)
  Size = rect\width * SizeOf(BGRA)
  BufferPitch = DrawingBufferPitch()
  
  *srcBuffer = awe_renderbuffer_get_buffer(*RenderBuffer) + rect\y * BufferPitch + rect\x * SizeOf(BGRA)
  *destBuffer = DrawingBuffer() + (awe_renderbuffer_get_height(*RenderBuffer) - rect\y - 1) * BufferPitch + rect\x * SizeOf(BGRA)
  
  For y = 1 To rect\height
    CopyMemory(*srcBuffer, *destBuffer, Size)
    *srcBuffer + BufferPitch
    *destBuffer - BufferPitch
  Next
EndProcedure

; #PB_PixelFormat_32Bits_BGR
Procedure Awe_RedrawAwesomium_BGR32(*Awesomium.Awesomium)
  Protected *RenderBuffer, *srcBuffer, *destBuffer
  Protected rect.awe_rect
  Protected y.i, Size.i, BufferPitch.i
  
  If Not *Awesomium\RepaintEverything
    awe_webview_get_dirty_bounds(*Awesomium\WebView, @rect)
    *RenderBuffer = awe_webview_render(*Awesomium\WebView)
  Else
    *RenderBuffer = awe_webview_render(*Awesomium\WebView)
    rect\x = 0
    rect\y = 0
    rect\width = awe_renderbuffer_get_width(*RenderBuffer)
    rect\height = awe_renderbuffer_get_height(*RenderBuffer)
  EndIf
  Size = rect\width * SizeOf(BGRA)
  BufferPitch = DrawingBufferPitch()
  
  *srcBuffer = awe_renderbuffer_get_buffer(*RenderBuffer) + rect\y * BufferPitch + rect\x * SizeOf(BGRA)
  *destBuffer = DrawingBuffer() + rect\y * BufferPitch + rect\x * SizeOf(BGRA)
  
  For y = 1 To rect\height
    CopyMemory(*srcBuffer, *destBuffer, Size)
    *srcBuffer + BufferPitch
    *destBuffer + BufferPitch
  Next
EndProcedure

; #PB_PixelFormat_24Bits_BGR | #PB_PixelFormat_ReversedY
Procedure Awe_RedrawAwesomium_BGR24Y(*Awesomium.Awesomium, DrawAll.i = #False)
  Protected Width.i, Height.i
  Protected *Buffer, *RenderBuffer, *srcPixel.BGRA, *destPixel.BGR
  Protected X.i, Y.i
  Protected rect.awe_rect 
  Protected DrawingBufferPitch.i, *DrawingBuffer

  
  If Not DrawAll
    awe_webview_get_dirty_bounds(*Awesomium\WebView, @rect)
  EndIf  
  *RenderBuffer = awe_webview_render(*Awesomium\WebView)
  *Buffer = awe_renderbuffer_get_buffer(*RenderBuffer)
  Width = awe_renderbuffer_get_width(*RenderBuffer)
  Height = awe_renderbuffer_get_height(*RenderBuffer)  
  If DrawAll
    rect\width = Width
    rect\height = Height
  EndIf
  
  StartDrawing(CanvasOutput(*Awesomium\Gadget))
    rect\height + rect\y - 1
    DrawingBufferPitch = DrawingBufferPitch()
    *DrawingBuffer = DrawingBuffer()
    For y = rect\y To rect\height
      *srcPixel = *Buffer + (y * Width + rect\x) * SizeOf(BGRA)
      *destPixel = *DrawingBuffer + (Height - y - 1) * DrawingBufferPitch + rect\x * SizeOf(BGR)
      For x = 1 To rect\width
        CopyMemory(*srcPixel, *destPixel, SizeOf(BGR))
        *srcPixel + SizeOf(BGRA)
        *destPixel + SizeOf(BGR)
      Next
    Next
  StopDrawing()
EndProcedure


Procedure Awe_RedrawAwesomiumGadget2(*Awesomium.Awesomium, DrawAll.i = #False)
  Protected srcWidth.i, destWidth.i
  Protected srcHeight.i, destHeight.i
  Protected *Buffer, *RenderBuffer, *srcPixel.BGRA, *destPixel.BGR
  Protected X.i, Y.i
  Protected rect.awe_rect
  If awe_webview_is_resizing(*Awesomium\WebView) : Debug "Resize" : ProcedureReturn : EndIf
  
  If Not DrawAll
    awe_webview_get_dirty_bounds(*Awesomium\WebView, @rect)
  EndIf  
  *RenderBuffer = awe_webview_render(*Awesomium\WebView)
  *Buffer = awe_renderbuffer_get_buffer(*RenderBuffer)
  srcWidth = awe_renderbuffer_get_width(*RenderBuffer)
  srcHeight = awe_renderbuffer_get_height(*RenderBuffer)  
  destWidth = GadgetWidth(*Awesomium\Gadget)
  destHeight = GadgetHeight(*Awesomium\Gadget)
  If Not DrawAll
    If rect\width > destWidth
      rect\width = destWidth
    EndIf
    If rect\height > destHeight
      rect\height = destHeight
    EndIf
  Else
    If srcWidth <= destWidth
      rect\width = srcWidth
    Else
      rect\width = destWidth
    EndIf
    If srcHeight <= destHeight
      rect\height = srcHeight
    Else
      rect\height = destHeight
    EndIf
  EndIf
  
  StartDrawing(CanvasOutput(*Awesomium\Gadget))
    rect\height + rect\y - 1
    For y = rect\y To rect\height
      *srcPixel = *Buffer + (y * srcWidth + rect\x) * SizeOf(BGRA)
      *destPixel = DrawingBuffer() + ((destHeight - y - 1) * destWidth + rect\x) * SizeOf(BGR)
      For x = 1 To rect\width
        CopyMemory(*srcPixel, *destPixel, SizeOf(BGR))
        *srcPixel + SizeOf(BGRA)
        *destPixel + SizeOf(BGR)
      Next
    Next
  StopDrawing()
  
;   StartDrawing(CanvasOutput(*Awesomium\Gadget))
;     If *Awesomium\Loading Or *Awesomium\TargetUrl
;       If *Awesomium\Loading
;         text = "Loading ..."
;       Else
;         text = *Awesomium\TargetUrl
;       EndIf
;       DrawingMode(#PB_2DDrawing_AlphaBlend)
;       RoundBox(2, 2, TextWidth(text)+12, TextHeight(text)+12, 4, 4, RGBA(0, 0, 0, 100))
;       DrawingMode(#PB_2DDrawing_Default)
;       DrawingMode(#PB_2DDrawing_Outlined | #PB_2DDrawing_Transparent)
;       RoundBox(3, 3, TextWidth(text)+10, TextHeight(text)+10, 4, 4, RGB(255, 255, 255))
;       DrawText(8, 8, text, RGB(255, 255, 255))
;     EndIf
;   StopDrawing()
EndProcedure

; #PB_PixelFormat_32Bits_RGB | #PB_PixelFormat_ReversedY
Procedure Awe_RedrawAwesomium_RGB32Y(*Awesomium.Awesomium, DrawAll.i = #False)
  Protected *RenderBuffer, *srcBuffer, *destBuffer
  Protected rect.awe_rect
  Protected y.i, Size.i, AweBufferPitch.i, DrawingBufferPitch.i
  
  awe_webview_get_dirty_bounds(*Awesomium\WebView, @rect)
  *RenderBuffer = awe_webview_render(*Awesomium\WebView)
  Size = rect\width * SizeOf(BGRA)
  AweBufferPitch = awe_renderbuffer_get_width(*RenderBuffer) * SizeOf(BGRA)
  DrawingBufferPitch = DrawingBufferPitch()
  
  *srcBuffer = awe_renderbuffer_get_buffer(*RenderBuffer) + rect\y * AweBufferPitch + rect\x * SizeOf(BGRA)
  *destBuffer = DrawingBuffer() + rect\y * DrawingBufferPitch + rect\x * SizeOf(BGRA)
  
  ;Debug "Update: " + Str(rect\x) + "x" + Str(rect\y) + " -> " + Str(rect\width) + "," + Str(rect\height) 
  
  For y = 1 To rect\height
    CopyMemory(*srcBuffer, *destBuffer, Size)
    *srcBuffer + AweBufferPitch
    *destBuffer + DrawingBufferPitch
  Next
  
EndProcedure


Procedure Awe_WindowCallback(WindowID.i, Message.i, wParam.l, lParam.l)
  Protected *Awesomium.Awesomium = AweWindow_Mapper(Str(WindowID))
  
  Select Message
    Case #WM_MOUSEMOVE
      awe_webview_inject_mouse_move(*Awesomium\WebView, lParam & $ffff, lParam >> 16 )
      
    Case #WM_LBUTTONDOWN
      If GetClassLong_(WindowID, #GCL_HCURSOR) = LoadCursor_(0, #IDC_ARROW)
        ReleaseCapture_()
        SendMessage_(WindowID, #WM_NCLBUTTONDOWN, #HTCAPTION, 0)
      Else
        awe_webview_inject_mouse_down(*Awesomium\WebView, #AWE_MB_LEFT)
      EndIf
        
    Case #WM_MBUTTONDOWN
      awe_webview_inject_mouse_down(*Awesomium\WebView, #AWE_MB_MIDDLE)
    Case #WM_RBUTTONDOWN
      awe_webview_inject_mouse_down(*Awesomium\WebView, #AWE_MB_Right)

    Case #WM_LBUTTONUP
      awe_webview_inject_mouse_up(*Awesomium\WebView, #AWE_MB_LEFT)
      
    Case #WM_MBUTTONUP
      awe_webview_inject_mouse_up(*Awesomium\WebView, #AWE_MB_MIDDLE)
    Case #WM_RBUTTONUP
      awe_webview_inject_mouse_up(*Awesomium\WebView, #AWE_MB_RIGHT)
      
    Case #WM_MOUSEWHEEL
      awe_webview_inject_mouse_wheel(*Awesomium\WebView, wParam >> 16, 0)
      
    Case #WM_MOUSEHWHEEL
      awe_webview_inject_mouse_wheel(*Awesomium\WebView, 0, wParam >> 16)
      
    Case #WM_SETFOCUS
      ;Debug "Focus"
      awe_webview_focus(*Awesomium\WebView)
      *Awesomium\hasFocus = #True
      
    Case #WM_KILLFOCUS
      ;Debug "KILLFOCUS"
      awe_webview_unfocus(*Awesomium\WebView)
      *Awesomium\hasFocus = #False
        
    Case #WM_KEYUP, #WM_KEYDOWN, #WM_SYSKEYUP, #WM_SYSKEYDOWN, #WM_CHAR, #WM_SYSCHAR
      If *Awesomium\hasFocus
        awe_webview_inject_keyboard_event_win(*Awesomium\WebView, Message, wParam, lParam)
      EndIf
  EndSelect
  
  ProcedureReturn #PB_ProcessPureBasicEvents
EndProcedure

ProcedureC Awe_FileRequesterCallback(*webview, select_multiple_files.i, *title, *default_path)
  Protected *Awesomium.Awesomium = Awe_Mapper(Str(*webview))
  Protected Flags.i = 0
  Protected File.s, *file
  If *Awesomium
    Select *Awesomium\Type
      Case #Awe_Type_Gadget, #Awe_Type_Window
        If select_multiple_files
          Flags = #PB_Requester_MultiSelection
          Debug "multi-file-selection not supported yet!"
        EndIf
        File = OpenFileRequester(awe_string_get_string(*title), awe_string_get_string(*default_path), "*.*", 0, Flags)
        If File 
          If select_multiple_files
            ;-todo: multiple file selection
            ; awe_webview_choose_multiple_files()
          Else
            *file = awe_string_create_from_utf16(File, Len(File))
            awe_webview_choose_file(*webview, *file)
            awe_string_destroy(*file)
          EndIf
        Else
          ; needed because otherwise awesomium doesn't call this function again!
          awe_webview_choose_file(*webview, awe_string_empty())
        EndIf
        
      Case #Awe_Type_Texture, #Awe_Type_Sprite
        If *Awesomium\CB_FileRequester
          *Awesomium\CB_FileRequester(*Awesomium, select_multiple_files, awe_string_get_string(*title), awe_string_get_string(*default_path))
        EndIf
    EndSelect
  EndIf  
EndProcedure

CompilerIf #PB_Compiler_Version < 461
  #PB_Cursor_LeftDownRightUp = #PB_Cursor_LeftDownUpRight
  #PB_Cursor_LeftUpRightDown = #PB_Cursor_LeftUpDownRight
CompilerEndIf
ProcedureC Awe_CursorChangeCallback(*webview, cursor.i)
  Protected *Awesomium.Awesomium = Awe_Mapper(Str(*webview))
  If *Awesomium
    Select *Awesomium\Type 
      Case #Awe_Type_Gadget
        Protected Gadget.i = *Awesomium\Gadget
          
        Select Cursor
          Case #AWE_CUR_POINTER
            SetGadgetAttribute(Gadget, #PB_Canvas_Cursor, #PB_Cursor_Default)
          Case #AWE_CUR_CROSS
            SetGadgetAttribute(Gadget, #PB_Canvas_Cursor, #PB_Cursor_Cross)
          Case #AWE_CUR_HAND
            SetGadgetAttribute(Gadget, #PB_Canvas_Cursor, #PB_Cursor_Hand)
          Case #AWE_CUR_IBEAM
            SetGadgetAttribute(Gadget, #PB_Canvas_Cursor, #PB_Cursor_IBeam)
          Case #AWE_CUR_WAIT
            SetGadgetAttribute(Gadget, #PB_Canvas_Cursor, #PB_Cursor_Busy)
          Case #AWE_CUR_HELP
            SetGadgetAttribute(Gadget, #PB_Canvas_Cursor, #PB_Cursor_Default)
          Case #AWE_CUR_EAST_RESIZE
            SetGadgetAttribute(Gadget, #PB_Canvas_Cursor, #PB_Cursor_LeftRight)
          Case #AWE_CUR_NORTH_RESIZE
            SetGadgetAttribute(Gadget, #PB_Canvas_Cursor, #PB_Cursor_UpDown)
          Case #AWE_CUR_NORTHEAST_RESIZE
            SetGadgetAttribute(Gadget, #PB_Canvas_Cursor, #PB_Cursor_LeftDownRightUp)
          Case #AWE_CUR_NORTHWEST_RESIZE
            SetGadgetAttribute(Gadget, #PB_Canvas_Cursor, #PB_Cursor_LeftUpRightDown)
          Case #AWE_CUR_SOUTH_RESIZE
            SetGadgetAttribute(Gadget, #PB_Canvas_Cursor, #PB_Cursor_UpDown)
          Case #AWE_CUR_SOUTHEAST_RESIZE
            SetGadgetAttribute(Gadget, #PB_Canvas_Cursor, #PB_Cursor_LeftUpRightDown)
          Case #AWE_CUR_SOUTHWEST_RESIZE
            SetGadgetAttribute(Gadget, #PB_Canvas_Cursor, #PB_Cursor_LeftDownRightUp)
          Case #AWE_CUR_WEST_RESIZE
            SetGadgetAttribute(Gadget, #PB_Canvas_Cursor, #PB_Cursor_LeftRight)
          Case #AWE_CUR_NORTHSOUTH_RESIZE
            SetGadgetAttribute(Gadget, #PB_Canvas_Cursor, #PB_Cursor_UpDown)
          Case #AWE_CUR_EASTWEST_RESIZE
            SetGadgetAttribute(Gadget, #PB_Canvas_Cursor, #PB_Cursor_LeftRight)
          Case #AWE_CUR_NORTHEAST_SOUTHWEST_RESIZE
            SetGadgetAttribute(Gadget, #PB_Canvas_Cursor, #PB_Cursor_LeftDownRightUp)
          Case #AWE_CUR_NORTHWEST_SOUTHEAST_RESIZE
            SetGadgetAttribute(Gadget, #PB_Canvas_Cursor, #PB_Cursor_LeftUpRightDown)
          Case #AWE_CUR_COLUMN_RESIZE
            SetGadgetAttribute(Gadget, #PB_Canvas_Cursor, #PB_Cursor_LeftRight)
          Case #AWE_CUR_ROW_RESIZE
            SetGadgetAttribute(Gadget, #PB_Canvas_Cursor, #PB_Cursor_UpDown)
          Case #AWE_CUR_MIDDLE_PANNING
            SetGadgetAttribute(Gadget, #PB_Canvas_Cursor, #PB_Cursor_Default)
          Case #AWE_CUR_EAST_PANNING
            SetGadgetAttribute(Gadget, #PB_Canvas_Cursor, #PB_Cursor_Default)
          Case #AWE_CUR_NORTH_PANNING
            SetGadgetAttribute(Gadget, #PB_Canvas_Cursor, #PB_Cursor_Default)
          Case #AWE_CUR_NORTHEAST_PANNING
            SetGadgetAttribute(Gadget, #PB_Canvas_Cursor, #PB_Cursor_Default)
          Case #AWE_CUR_NORTHWEST_PANNING
            SetGadgetAttribute(Gadget, #PB_Canvas_Cursor, #PB_Cursor_Default)
          Case #AWE_CUR_SOUTH_PANNING
            SetGadgetAttribute(Gadget, #PB_Canvas_Cursor, #PB_Cursor_Default)
          Case #AWE_CUR_SOUTHEAST_PANNING
            SetGadgetAttribute(Gadget, #PB_Canvas_Cursor, #PB_Cursor_Default)
          Case #AWE_CUR_SOUTHWEST_PANNING
            SetGadgetAttribute(Gadget, #PB_Canvas_Cursor, #PB_Cursor_Default)
          Case #AWE_CUR_WEST_PANNING
            SetGadgetAttribute(Gadget, #PB_Canvas_Cursor, #PB_Cursor_Default)
          Case #AWE_CUR_MOVE
            SetGadgetAttribute(Gadget, #PB_Canvas_Cursor, #PB_Cursor_Arrows)
          Case #AWE_CUR_VERTICAL_TEXT
            SetGadgetAttribute(Gadget, #PB_Canvas_Cursor, #PB_Cursor_IBeam)
          Case #AWE_CUR_CELL
            SetGadgetAttribute(Gadget, #PB_Canvas_Cursor, #PB_Cursor_Default)
          Case #AWE_CUR_CONTEXT_MENU
            SetGadgetAttribute(Gadget, #PB_Canvas_Cursor, #PB_Cursor_Default)
          Case #AWE_CUR_ALIAS
            SetGadgetAttribute(Gadget, #PB_Canvas_Cursor, #PB_Cursor_Default)
          Case #AWE_CUR_PROGRESS
            SetGadgetAttribute(Gadget, #PB_Canvas_Cursor, #PB_Cursor_Default)
          Case #AWE_CUR_NO_DROP
            SetGadgetAttribute(Gadget, #PB_Canvas_Cursor, #PB_Cursor_Denied)
          Case #AWE_CUR_COPY
            SetGadgetAttribute(Gadget, #PB_Canvas_Cursor, #PB_Cursor_Default)
          Case #AWE_CUR_NONE
            SetGadgetAttribute(Gadget, #PB_Canvas_Cursor, #PB_Cursor_Invisible)
          Case #AWE_CUR_NOT_ALLOWED
            SetGadgetAttribute(Gadget, #PB_Canvas_Cursor, #PB_Cursor_Denied)
          Case #AWE_CUR_ZOOM_IN
            SetGadgetAttribute(Gadget, #PB_Canvas_Cursor, #PB_Cursor_Default)
          Case #AWE_CUR_ZOOM_OUT
            SetGadgetAttribute(Gadget, #PB_Canvas_Cursor, #PB_Cursor_Default)
          Case #AWE_CUR_CUSTOM 
            SetGadgetAttribute(Gadget, #PB_Canvas_Cursor, #PB_Cursor_Default)
        EndSelect
        
      Case #Awe_Type_Window
        Protected WindowID.i = WindowID(*Awesomium\Window)
        
        Select Cursor
          Case #AWE_CUR_POINTER
            SetClassLong_(WindowID, #GCL_HCURSOR, LoadCursor_(0, #IDC_ARROW))
          Case #AWE_CUR_CROSS
            SetClassLong_(WindowID, #GCL_HCURSOR, LoadCursor_(0, #IDC_CROSS))
          Case #AWE_CUR_HAND
            SetClassLong_(WindowID, #GCL_HCURSOR, LoadCursor_(0, #IDC_HAND))
          Case #AWE_CUR_IBEAM
            SetClassLong_(WindowID, #GCL_HCURSOR, LoadCursor_(0, #IDC_IBEAM))
          Case #AWE_CUR_WAIT
            SetClassLong_(WindowID, #GCL_HCURSOR, LoadCursor_(0, #IDC_WAIT))
          Case #AWE_CUR_HELP
            SetClassLong_(WindowID, #GCL_HCURSOR, LoadCursor_(0, #IDC_HELP))
          Case #AWE_CUR_EAST_RESIZE
            SetClassLong_(WindowID, #GCL_HCURSOR, LoadCursor_(0, #IDC_SIZEWE))
          Case #AWE_CUR_NORTH_RESIZE
            SetClassLong_(WindowID, #GCL_HCURSOR, LoadCursor_(0, #IDC_SIZENS))
          Case #AWE_CUR_NORTHEAST_RESIZE
            SetGadgetAttribute(Gadget, #PB_Canvas_Cursor, #PB_Cursor_LeftDownRightUp)
          Case #AWE_CUR_NORTHWEST_RESIZE
            SetGadgetAttribute(Gadget, #PB_Canvas_Cursor, #PB_Cursor_LeftUpRightDown)
          Case #AWE_CUR_SOUTH_RESIZE
            SetClassLong_(WindowID, #GCL_HCURSOR, LoadCursor_(0, #IDC_SIZENS))
          Case #AWE_CUR_SOUTHEAST_RESIZE
            SetGadgetAttribute(Gadget, #PB_Canvas_Cursor, #PB_Cursor_LeftUpRightDown)
          Case #AWE_CUR_SOUTHWEST_RESIZE
            SetGadgetAttribute(Gadget, #PB_Canvas_Cursor, #PB_Cursor_LeftDownRightUp)
          Case #AWE_CUR_WEST_RESIZE
            SetClassLong_(WindowID, #GCL_HCURSOR, LoadCursor_(0, #IDC_SIZEWE))
          Case #AWE_CUR_NORTHSOUTH_RESIZE
            SetClassLong_(WindowID, #GCL_HCURSOR, LoadCursor_(0, #IDC_SIZENS))
          Case #AWE_CUR_EASTWEST_RESIZE
            SetClassLong_(WindowID, #GCL_HCURSOR, LoadCursor_(0, #IDC_SIZEWE))
          Case #AWE_CUR_NORTHEAST_SOUTHWEST_RESIZE
            SetGadgetAttribute(Gadget, #PB_Canvas_Cursor, #PB_Cursor_LeftDownRightUp)
          Case #AWE_CUR_NORTHWEST_SOUTHEAST_RESIZE
            SetGadgetAttribute(Gadget, #PB_Canvas_Cursor, #PB_Cursor_LeftUpRightDown)
          Case #AWE_CUR_COLUMN_RESIZE
            SetClassLong_(WindowID, #GCL_HCURSOR, LoadCursor_(0, #IDC_SIZEWE))
          Case #AWE_CUR_ROW_RESIZE
            SetClassLong_(WindowID, #GCL_HCURSOR, LoadCursor_(0, #IDC_SIZENS))
          Case #AWE_CUR_MIDDLE_PANNING
            SetClassLong_(WindowID, #GCL_HCURSOR, LoadCursor_(0, #IDC_ARROW))
          Case #AWE_CUR_EAST_PANNING
            SetClassLong_(WindowID, #GCL_HCURSOR, LoadCursor_(0, #IDC_ARROW))
          Case #AWE_CUR_NORTH_PANNING
            SetClassLong_(WindowID, #GCL_HCURSOR, LoadCursor_(0, #IDC_ARROW))
          Case #AWE_CUR_NORTHEAST_PANNING
            SetClassLong_(WindowID, #GCL_HCURSOR, LoadCursor_(0, #IDC_ARROW))
          Case #AWE_CUR_NORTHWEST_PANNING
            SetClassLong_(WindowID, #GCL_HCURSOR, LoadCursor_(0, #IDC_ARROW))
          Case #AWE_CUR_SOUTH_PANNING
            SetClassLong_(WindowID, #GCL_HCURSOR, LoadCursor_(0, #IDC_ARROW))
          Case #AWE_CUR_SOUTHEAST_PANNING
            SetClassLong_(WindowID, #GCL_HCURSOR, LoadCursor_(0, #IDC_ARROW))
          Case #AWE_CUR_SOUTHWEST_PANNING
            SetClassLong_(WindowID, #GCL_HCURSOR, LoadCursor_(0, #IDC_ARROW))
          Case #AWE_CUR_WEST_PANNING
            SetClassLong_(WindowID, #GCL_HCURSOR, LoadCursor_(0, #IDC_ARROW))
          Case #AWE_CUR_MOVE
            SetClassLong_(WindowID, #GCL_HCURSOR, LoadCursor_(0, #IDC_SIZEALL))
          Case #AWE_CUR_VERTICAL_TEXT
            SetClassLong_(WindowID, #GCL_HCURSOR, LoadCursor_(0, #IDC_IBEAM))
          Case #AWE_CUR_CELL
            SetClassLong_(WindowID, #GCL_HCURSOR, LoadCursor_(0, #IDC_ARROW))
          Case #AWE_CUR_CONTEXT_MENU
            SetClassLong_(WindowID, #GCL_HCURSOR, LoadCursor_(0, #IDC_ARROW))
          Case #AWE_CUR_ALIAS
            SetClassLong_(WindowID, #GCL_HCURSOR, LoadCursor_(0, #IDC_ARROW))
          Case #AWE_CUR_PROGRESS
            SetClassLong_(WindowID, #GCL_HCURSOR, LoadCursor_(0, #IDC_ARROW))
          Case #AWE_CUR_NO_DROP
            SetClassLong_(WindowID, #GCL_HCURSOR, LoadCursor_(0, #IDC_NO))
          Case #AWE_CUR_COPY
            SetClassLong_(WindowID, #GCL_HCURSOR, LoadCursor_(0, #IDC_ARROW))
          Case #AWE_CUR_NONE
            ;SetGadgetAttribute(Gadget, #PB_Canvas_Cursor, #PB_Cursor_Invisible)
          Case #AWE_CUR_NOT_ALLOWED
            SetClassLong_(WindowID, #GCL_HCURSOR, LoadCursor_(0, #IDC_NO))
          Case #AWE_CUR_ZOOM_IN
            SetClassLong_(WindowID, #GCL_HCURSOR, LoadCursor_(0, #IDC_ARROW))
          Case #AWE_CUR_ZOOM_OUT
            SetClassLong_(WindowID, #GCL_HCURSOR, LoadCursor_(0, #IDC_ARROW))
          Case #AWE_CUR_CUSTOM 
            SetClassLong_(WindowID, #GCL_HCURSOR, LoadCursor_(0, #IDC_ARROW))
        EndSelect       
        
      Case #Awe_Type_Texture, #Awe_Type_Sprite
        If *Awesomium\CB_CursorChange
          *Awesomium\CB_CursorChange(*Awesomium, Cursor)
        EndIf
    EndSelect
  EndIf
EndProcedure


ProcedureC Awe_TitleCallback(*webview, *title, *framename)
  Protected *Awesomium.Awesomium = Awe_Mapper(Str(*webview))
  Protected Title.s = awe_string_get_string(*title)
  Protected FrameName.s = awe_string_get_string(*framename)
  If *Awesomium
    If FrameName = ""
      *Awesomium\Title = Title
    EndIf
    If *Awesomium\CB_Title
      *Awesomium\CB_Title(*Awesomium, Title, FrameName)
    EndIf
  EndIf  
EndProcedure

Procedure Awe_LoadFavicon(*Awesomium.Awesomium)
  Protected *javascript, *js_object, *strUrl, Url.s
  Protected TmpFile.s, tmpImage.i, oldImage.i
  Protected Javascript.s = "(function(){"
  Javascript + "headerElement = document.getElementsByTagName('head')[0];"
  Javascript + "link = headerElement.getElementsByTagName('link');"
  Javascript + "for (i = 0; i < link.length; i++) {"
  Javascript + "if (link[i].getAttribute('rel') == 'shortcut icon') {"
  Javascript + "return link[i].getAttribute('href');"
  Javascript + "}"
  Javascript + "}"
  Javascript + "})();"
  *javascript = awe_string_create_from_utf16(Javascript, Len(Javascript))
  *js_object = awe_webview_execute_javascript_with_result(*Awesomium\WebView, *javascript, awe_string_empty(), 0)
  *strUrl = awe_jsvalue_to_string(*js_object)
  Url = awe_string_get_string(*strUrl)
  awe_string_destroy(*strUrl)
  awe_string_destroy(*javascript)
  awe_jsvalue_destroy(*js_object)
  
  If Not Url
    Protected *url = awe_webview_get_url(*Awesomium\WebView)
    Url = GetURLPart(awe_string_get_string(*url), #PB_URL_Protocol) + "://" + GetURLPart(awe_string_get_string(*url), #PB_URL_Site) + "/favicon.ico"
    awe_string_destroy(*url)
  ElseIf LCase(Left(Url, 7)) <> "http://"
    If Left(Url, 2) = "//"
      Url = "http:" + Url
    ElseIf Left(Url, 1) = "/"
      *url = awe_webview_get_url(*Awesomium\WebView)
      Url = GetURLPart(awe_string_get_string(*url), #PB_URL_Protocol) + "://" + GetURLPart(awe_string_get_string(*url), #PB_URL_Site) + Url
      awe_string_destroy(*url)
    Else
      Url = "http://" + Url
    EndIf
  EndIf

  If Url <> *Awesomium\FaviconPath
    *Awesomium\FaviconPath = Url
    oldImage = *Awesomium\Favicon
    tmpFile  = GetTemporaryDirectory() + "Fav" + Str(*Awesomium)+ ".ico"
;     Debug tmpFile
;     Debug "Fav: " + Url
;     Debug ""
    If ReceiveHTTPFile(Url, tmpFile)
      tmpImage = LoadImage(#PB_Any, tmpFile)
      If tmpImage
        *Awesomium\Favicon = CreateImage(#PB_Any, ImageWidth(tmpImage), ImageHeight(tmpImage), 32)
        StartDrawing(ImageOutput(*Awesomium\Favicon))
        DrawingMode(#PB_2DDrawing_AllChannels)
        DrawImage(ImageID(tmpImage), 0, 0)
        StopDrawing()
        FreeImage(tmpImage)
        DeleteFile(tmpFile)
      Else
        *Awesomium\Favicon = #Null
      EndIf
    Else
      *Awesomium\Favicon = #Null
    EndIf
    If *Awesomium\CB_Favicon
      If *Awesomium\Favicon
        *Awesomium\CB_Favicon(*Awesomium, CopyImage(*Awesomium\Favicon, #PB_Any))
      Else
        *Awesomium\CB_Favicon(*Awesomium, #Null)
      EndIf
    EndIf
  EndIf
  If oldImage : FreeImage(oldImage) : EndIf
EndProcedure

ProcedureC Awe_DomReadyCallback(*webview)
;   If FindMapElement(Awe_Mapper(), Str(*webview))
;     Protected Javascript.s = "documentElement.write('<script type="+Chr(34)+"text/javascript"+Chr(34)+" src="+Chr(34)+"http://ajax.googleapis.com/ajax/libs/jquery/1.4.4/jquery.min.js"+Chr(34)+"/>);"
;     Javascript = "$('body').css('background-color', 'transparent');"
;     Debug Javascript
;     Protected *Awesomium.Awesomium = Awe_Mapper()
;     Protected *javascript = awe_string_create_from_utf16(Javascript, Len(Javascript))
;     awe_webview_execute_javascript(*Awesomium\WebView, *javascript, awe_string_empty())
;     awe_string_destroy(*javascript)
;   EndIf
  Protected *Awesomium.Awesomium = Awe_Mapper(Str(*webview))
  If *Awesomium 
    If *Awesomium\CB_DomReady
      *Awesomium\CB_DomReady(*Awesomium)
    EndIf
    If *Awesomium\CB_Favicon
      Awe_LoadFavicon(*Awesomium)
    EndIf
  EndIf
EndProcedure

ProcedureC Awe_JSConsoleCallback(*webview, *message, line_number.l, *source)
  Protected *Awesomium.Awesomium = Awe_Mapper(Str(*webview))
  If *Awesomium And *Awesomium\CB_JSMessage
    *Awesomium\CB_JSMessage(*Awesomium, awe_string_get_string(*message), line_number, awe_string_get_string(*source))
  EndIf
  
;   If FindMapElement(Awe_Mapper(), Str(*webview))
;     Debug "Error (" + Str(line_number) +"): " + awe_string_get_string(*message)
;     Debug "Source: " + awe_string_get_string(*source)
;   EndIf
EndProcedure

ProcedureC Awe_JSDialogCallback(*webview, request_id.l, dialog_flags.l, *message, *default_prompt, *frame_url)
  Protected *Awesomium.Awesomium = Awe_Mapper(Str(*webview))
  If *Awesomium And *Awesomium\CB_JSDialog
    *Awesomium\CB_JSDialog(*Awesomium, request_id, dialog_flags, awe_string_get_string(*message), awe_string_get_string(*default_prompt), awe_string_get_string(*frame_url))
  EndIf
EndProcedure
  
ProcedureC Awe_DownloadCallback(*webview, *download)
  Protected *Awesomium.Awesomium = Awe_Mapper(Str(*webview))
  If *Awesomium And *Awesomium\CB_DownloadFile
    *Awesomium\CB_DownloadFile(*Awesomium, awe_string_get_string(*download))
  EndIf
EndProcedure

ProcedureC Awe_ExternalLinkCallback(*webview, *url, *source)
  Protected *Awesomium.Awesomium = Awe_Mapper(Str(*webview))
  Protected Url.s = awe_string_get_string(*url)
  Protected Source.s = awe_string_get_string(*source)
  If *Awesomium
    If *Awesomium\CB_OpenExtLink
      *Awesomium\CB_OpenExtLink(*Awesomium, Url, Source)
    EndIf
    If *Awesomium\CB_OpenLink
      *Awesomium\CB_OpenLink(*Awesomium, Url)
    EndIf
    ;RunProgram(awe_string_get_string(*url))
    ;Debug "external link: " + awe_string_get_string(*url)
    ;awe_webview_load_url(*webview, *url, awe_string_empty(), awe_string_empty(), awe_string_empty())
  EndIf
EndProcedure

ProcedureC Awe_BeginNavigationCallback(*webview, *url, *frame_name)
  Protected *Awesomium.Awesomium = Awe_Mapper(Str(*webview))
  Protected Url.s = awe_string_get_string(*url)
  Protected FrameName.s = awe_string_get_string(*frame_name)
  If *Awesomium
    If FrameName = ""
      *Awesomium\Url = Url
    EndIf
    If *Awesomium\CB_OpenNewLink
      *Awesomium\CB_OpenNewLink(*Awesomium, Url, FrameName)
    EndIf
    If *Awesomium\CB_OpenLink
      *Awesomium\CB_OpenLink(*Awesomium, Url)
    EndIf
    
;     CompilerIf #PB_Compiler_Debugger
;       Protected Frame.s = awe_string_get_string(*frame_name)
;       If Frame : Frame = " (" + Frame + ")" : EndIf
;       Debug "begin navigation: " + awe_string_get_string(*url) + Frame
;     CompilerEndIf
  EndIf
EndProcedure

ProcedureC Awe_TooltipCallback(*webview, *tooltip)
  Protected *Awesomium.Awesomium = Awe_Mapper(Str(*webview))
  Protected Text.s = awe_string_get_string(*tooltip), TI.ToolInfo
  If *Awesomium 
    ;Debug "Tooltip: " + awe_string_get_string(*tooltip)
    Select *Awesomium\Type
      Case #Awe_Type_Gadget
        GadgetToolTip(*Awesomium\Gadget, Text)
      Case #Awe_Type_Window
        ;-todo: window tooltip
        
        If Text
          TI\cbSize = SizeOf(ToolInfo)
          TI\hwnd = WindowID(*Awesomium\Window)
          TI\uId = WindowID(*Awesomium\Window)
          TI\lpszText = @Text  
          SendMessage_(*Awesomium\hToolTip, #TTM_UPDATETIPTEXT, 0, TI)
          SendMessage_(*Awesomium\hToolTip, #TTM_ACTIVATE, #True, 0)
        Else
          SendMessage_(*Awesomium\hToolTip, #TTM_ACTIVATE, #False, 0)
        EndIf

      Case #Awe_Type_Texture, #Awe_Type_Sprite
        If *Awesomium\CB_Tooltip
          *Awesomium\CB_Tooltip(*Awesomium, Text)
        EndIf
    EndSelect
  EndIf  
EndProcedure
  
ProcedureC Awe_TargetLinkCallback(*webview, *url)
  Protected *Awesomium.Awesomium = Awe_Mapper(Str(*webview))
  Protected Url.s = awe_string_get_string(*url)

  If *Awesomium 
    *Awesomium\TargetUrl = Url
    If *Awesomium\CB_TargetChange
      *Awesomium\CB_TargetChange(*Awesomium, Url)
    EndIf
  EndIf
EndProcedure

ProcedureC Awe_BeginLoadingCallback(*webview, *url, *frame_name, status_code.l, *mime_type)
  Protected *Awesomium.Awesomium = Awe_Mapper(Str(*webview))
  If *Awesomium
;     CompilerIf #PB_Compiler_Debugger
;       Protected Frame.s = awe_string_get_string(*frame_name)
;       If Frame : Frame = " (" + Frame + ")" : EndIf
;       Debug "begin loading: " + awe_string_get_string(*url) + Frame
;     CompilerEndIf
    *Awesomium\Loading = #False
    If *Awesomium\CB_BeginLoading
      *Awesomium\CB_BeginLoading(*Awesomium, awe_string_get_string(*url), awe_string_get_string(*frame_name), status_code, awe_string_get_string(*mime_type))
    EndIf
  EndIf
EndProcedure

ProcedureC Awe_FinishLoadingCallback(*webview)
  Protected *Awesomium.Awesomium = Awe_Mapper(Str(*webview))
  If *Awesomium
    ;Debug "loading finished"
    *Awesomium\Loading = #False
    If *Awesomium\CB_FinishLoading
      *Awesomium\CB_FinishLoading(*Awesomium)
    EndIf
  EndIf
EndProcedure

ProcedureC Awe_PageContentsCallback(*webview, *url, *contents)
  Protected *Awesomium.Awesomium = Awe_Mapper(Str(*webview))
  If *Awesomium And *Awesomium\CB_PageContents
    *Awesomium\CB_PageContents(*Awesomium, awe_string_get_string(*url), awe_string_get_string(*contents))
  EndIf  
EndProcedure

ProcedureC Awe_ResourceCallback(*webview,  *url, status_code.l, was_cached.b, request_time_ms.q, response_time_ms.q, expected_content_size.q, *mime_type)
  Protected *Awesomium.Awesomium = Awe_Mapper(Str(*webview))
  If *Awesomium And *Awesomium\CB_Resource
    *Awesomium\CB_Resource(*Awesomium, awe_string_get_string(*url), status_code, was_cached, request_time_ms, response_time_ms, expected_content_size, awe_string_get_string(*mime_type))
  EndIf
EndProcedure

ProcedureC Awe_ShowContextMenu(*webview, mouse_x.l, mouse_y.l, type.l, media_state.l, *link_url, *src_url, *page_url, *frame_url, *selection_text, is_editable.b, edit_flags.l)
  Protected *Awesomium.Awesomium = Awe_Mapper(Str(*webview))
  If *Awesomium And *Awesomium\CB_ShowContextMenu
    *Awesomium\CB_ShowContextMenu(*Awesomium, mouse_x, mouse_y, type, media_state, awe_string_get_string(*link_url), awe_string_get_string(*src_url), awe_string_get_string(*page_url), awe_string_get_string(*frame_url), awe_string_get_string(*selection_text), is_editable, edit_flags)
  EndIf  
EndProcedure

ProcedureC Awe_JSCallback(*webview, *object_name, *callback_name, *arguments)
  Protected *Awesomium.Awesomium = Awe_Mapper(Str(*webview))
  If *Awesomium And *Awesomium\CB_JSCallback
    *Awesomium\CB_JSCallback(*Awesomium, awe_string_get_string(*object_name), awe_string_get_string(*callback_name), *arguments)
  EndIf  
EndProcedure

Procedure SplitString(String.s, Chars.s, List DataLine.s())
  Protected Pos.i = FindString(String, Chars)
  Protected LenChars.i = Len(Chars)
  Protected PosBegin.i = -LenChars + 1
  ClearList(DataLine())
  
  If Not String : ProcedureReturn : EndIf
  If Pos
    Repeat
      AddElement(DataLine())
      DataLine() = Mid(String, PosBegin + LenChars, Pos - PosBegin - LenChars)
      
      PosBegin = Pos
      Pos = FindString(String, Chars, Pos + LenChars)
    Until Not Pos
    
    AddElement(DataLine())
    DataLine() = Mid(String, PosBegin + LenChars)
  Else
    AddElement(DataLine())
    DataLine() = String
  EndIf
EndProcedure


ProcedureC.i Awe_ResourceRequestCallback(*webview, *request)
  Protected *Awesomium.Awesomium = Awe_Mapper(Str(*webview))
  Protected String.s, String2.s, Url.s
  Protected *element, *string, Result.i
  Protected Count.i, Count2.i, i.i, ii.i
  Protected CB_ResourceRequest.AweP_ResourceRequestCallback
  Protected Pos.i, Boundary.s, InputName.s
  Protected Content.i
  Protected NewList DataLine.s()
  
  
  If *Awesomium And *Awesomium\InitResRequest
    *string = awe_resource_request_get_url(*request)
    Url = awe_string_get_string(*string)
    awe_string_destroy(*string)
    
    If FindMapElement(*Awesomium\CB_ResourceRequest(), Url) Or FindMapElement(*Awesomium\CB_ResourceRequest(), "")
      Protected AweRequest.Awesomium_Request
      Protected *AweResponse
      AweRequest\Awe_Request = *request
      AweRequest\Url = Url
      *string = awe_resource_request_get_method(*request)
      AweRequest\Method = awe_string_get_string(*string)
      awe_string_destroy(*string)
      *string = awe_resource_request_get_referrer(*request)
      AweRequest\Referrer = awe_string_get_string(*string)
      awe_string_destroy(*string)
      *string = awe_resource_request_get_extra_headers(*request)
      AweRequest\Headers = awe_string_get_string(*string)
      SplitString(AweRequest\Headers, Chr(13) + Chr(10), DataLine())
      awe_string_destroy(*string)
      
      Count = awe_resource_request_get_num_upload_elements(*request) - 1
      SelectElement(DataLine(), 1)
      If FindString(DataLine(), "Content-Type: application/x-www-form-urlencoded")
        For i = 0 To Count
          *element = awe_resource_request_get_upload_element(*request, i)
          If awe_upload_element_is_bytes(*element)
            *string = awe_upload_element_get_bytes(*element)
            String = awe_string_get_string(*string)
            awe_string_destroy(*string)
            
            Count2 = CountString(String, "&") + 1
            For ii = 1 To Count2
              String2 = StringField(String, ii, "&")
              AweRequest\Element(URLDecoder(StringField(String2, 1, "="))) = URLDecoder(StringField(String2, 2, "="))
            Next
          ElseIf awe_upload_element_is_file_path(*element)
            ; can't be
            *string = awe_upload_element_get_file_path(*element)
            AweRequest\Element("error["+Str(i)+"]") = awe_string_get_string(*string)
            awe_string_destroy(*string)
          EndIf
        Next      
        
      Else
        Pos = FindString(DataLine(), "Content-Type: multipart/form-Data;") + 33
        Boundary = "--" + Mid(DataLine(), FindString(DataLine(), "boundary=", Pos) + 9)
        
        For i = 0 To Count
          *element = awe_resource_request_get_upload_element(*request, i)
          If awe_upload_element_is_bytes(*element)
            *string = awe_upload_element_get_bytes(*element)
            Debug awe_string_get_string(*string)
            SplitString(awe_string_get_string(*string), Chr(13) + Chr(10), DataLine())
            awe_string_destroy(*string)
            
            ResetList(DataLine())
            While NextElement(DataLine())
              If Left(DataLine(), Len(Boundary)) = Boundary
                Content = #False
                Continue
              
              ElseIf Left(DataLine(), 31) = "Content-Disposition: form-data;"
                Pos = FindString(DataLine(), Chr(34))
                InputName = Mid(DataLine(), Pos + 1, FindString(DataLine(), Chr(34), Pos + 1) - Pos - 1)
                
              ElseIf Content
                If FindMapElement(AweRequest\Element(), InputName)
                  AweRequest\Element() + Chr(13) + Chr(10) + DataLine()
                Else
                  AweRequest\Element(InputName) = DataLine()
                EndIf
 
              ElseIf DataLine() = ""
                Content = #True
              EndIf
            Wend
          ElseIf awe_upload_element_is_file_path(*element)
            *string = awe_upload_element_get_file_path(*element)
            AweRequest\Element(InputName) = awe_string_get_string(*string)
            awe_string_destroy(*string)
          EndIf
        Next      
      EndIf
      
      CB_ResourceRequest = *Awesomium\CB_ResourceRequest()
      *AweResponse = CB_ResourceRequest(*Awesomium, @AweRequest)
      If AweRequest\Cancle
        awe_resource_request_cancel(*request)
      ElseIf *AweResponse
        ProcedureReturn *AweResponse
      EndIf
    EndIf
  EndIf
  ProcedureReturn #Null
EndProcedure

Procedure Awe_CreateAwesomium(Type.i, ID.i, Width.i, Height, Url.s = "")
  Protected *strUrl
  
  AddElement(Awesomium())
  FreeMap(Awesomium()\CB_ResourceRequest())
  Awesomium()\InitResRequest = #False
  
  Awesomium()\Type = Type
  Awesomium()\ID = ID
  Awesomium()\WebView = awe_webcore_create_webview(Width, Height, #False)
  awe_webview_set_callback_change_cursor(Awesomium()\WebView, @Awe_CursorChangeCallback())
  awe_webview_set_callback_open_external_link(Awesomium()\WebView, @Awe_ExternalLinkCallback())
  awe_webview_set_callback_change_target_url(Awesomium()\WebView, @Awe_TargetLinkCallback())
  awe_webview_set_callback_begin_navigation(Awesomium()\WebView, @Awe_BeginNavigationCallback())
  awe_webview_set_callback_request_download(Awesomium()\WebView, @Awe_DownloadCallback())
  awe_webview_set_callback_begin_loading(Awesomium()\WebView, @Awe_BeginLoadingCallback())
  awe_webview_set_callback_finish_loading(Awesomium()\WebView, @Awe_FinishLoadingCallback())
  awe_webview_set_callback_get_page_contents(Awesomium()\WebView, @Awe_PageContentsCallback())
  awe_webview_set_callback_change_tooltip(Awesomium()\WebView, @Awe_TooltipCallback())
  awe_webview_set_callback_receive_title(Awesomium() \WebView, @Awe_TitleCallback())
  awe_webview_set_callback_request_file_chooser(Awesomium()\WebView, @Awe_FileRequesterCallback())
  awe_webview_set_callback_dom_ready(Awesomium()\WebView, @Awe_DomReadyCallback())
  awe_webview_set_callback_js_console_message(Awesomium()\WebView, @Awe_JSConsoleCallback())
  awe_webview_set_callback_show_context_menu(Awesomium()\WebView, @Awe_ShowContextMenu())
  awe_webview_set_callback_js_callback(Awesomium()\WebView, @Awe_JSCallback())
  awe_webview_set_callback_resource_response(Awesomium()\WebView, @Awe_ResourceCallback())
  awe_webview_set_callback_resource_request(Awesomium()\WebView, @Awe_ResourceRequestCallback())
  Awe_Mapper(Str(Awesomium()\WebView)) = @Awesomium()
  If Type = #Awe_Type_Window
    SetWindowCallback(@Awe_WindowCallback(), Awesomium()\Window)
    AweWindow_Mapper(Str(WindowID(ID))) = @Awesomium()
  EndIf
  
  If Url
    Awesomium()\Url = Url
    *strUrl = awe_string_create_from_utf16(Url, Len(Url))
    awe_webview_load_url(Awesomium()\WebView, *strUrl, awe_string_empty(), awe_string_empty(), awe_string_empty())
    awe_string_destroy(*strUrl)
  EndIf 
  
  ProcedureReturn @Awesomium()
EndProcedure

; 1. author: Le Soldat Inconnu
; 2. author: STARGÅTE
; from http://www.purebasic.fr/english/viewtopic.php?f=12&t=39079
Procedure Awe_WindowBackground(Window.i, Image.i, Transparency.a=255)
  Protected WindowID.i = WindowID(Window)
  Protected ImageID.i  = ImageID(Image)
  Protected HDC.i      = CreateCompatibleDC_(#Null)
  Protected Object.i   = SelectObject_(HDC, ImageID)
  Protected Size.Size  : Size\cx = ImageWidth(Image) : Size\cy = ImageHeight(Image)
  Protected Point.Point
  Protected Blend.BLENDFUNCTION : Blend\SourceConstantAlpha = Transparency : Blend\AlphaFormat = 1
  ;SetWindowLong_(WindowID, #GWL_EXSTYLE, GetWindowLong_(WindowID, #GWL_EXSTYLE) | #WS_EX_LAYERED)
  UpdateLayeredWindow_(WindowID, 0, 0, @Size, HDC, @Point, 0, @Blend, 2)
  SelectObject_(HDC, Object)
  DeleteDC_(HDC)
EndProcedure

Procedure.i SelectAwesomium(ID.i)
  ForEach Awesomium()
    If Awesomium()\ID = ID
      ProcedureReturn @Awesomium()
    EndIf
  Next
  ProcedureReturn #False
EndProcedure
Macro isAwesomium(ID)
  SelectAwesomium(ID)  
EndMacro

; --------------------------------------------------------------
;- 
;- > Public Functions < <
;
; --------------------------------------------------------------

Procedure.i Awesomium_ToImage(*renderbuffer, Image.i = #Null)
  Protected Width.i = awe_renderbuffer_get_width(*renderbuffer)
  Protected Height.i = awe_renderbuffer_get_height(*renderbuffer)
  Protected *Pixel.BGRA
  Protected *Buffer = awe_renderbuffer_get_buffer(*renderbuffer)
  Protected X.i, Y.i
  
  If Not Image : Image = CreateImage(#PB_Any, Width, Height, 32) : EndIf
  StartDrawing(ImageOutput(Image))
  DrawingMode(#PB_2DDrawing_AllChannels)
  *Pixel = *Buffer
  For y = 1 To Height
    For x = 1 To Width
      Plot(X-1, Y-1, RGBA(*Pixel\Red & $FF, *Pixel\Green & $FF, *Pixel\Blue & $FF, *Pixel\Alpha & $FF))
      *Pixel + SizeOf(BGRA)
    Next
  Next
  StopDrawing()
  ProcedureReturn Image
EndProcedure

Procedure Awesomium_Free(*Awesomium.Awesomium)
  If *Awesomium
    ChangeCurrentElement(Awesomium(), *Awesomium)
    If FindMapElement(Awe_Mapper(), Str(Awesomium()\WebView))
      DeleteMapElement(Awe_Mapper())
    EndIf
    Select Awesomium()\Type
      Case #Awe_Type_Gadget
        HideGadget(Awesomium()\Gadget, #True)
        FreeGadget(Awesomium()\Gadget)
      Case #Awe_Type_Window
        CloseWindow(Awesomium()\Window)
        If FindMapElement(AweWindow_Mapper(), Str(WindowID(Awesomium()\Window)))
          DeleteMapElement(AweWindow_Mapper())
        EndIf
    EndSelect
    
    awe_webview_destroy(Awesomium()\WebView)
     DeleteElement(Awesomium())
  EndIf
EndProcedure

Procedure.i OpenAwesomiumWindow(X.i, Y.i, Width.i, Height.i, Title.s, Url.s = "", hToolTip.i = #Null)
  Protected Window.i = OpenWindow(#PB_Any, X, Y, Width, Height, Title, #PB_Window_BorderLess | #PB_Window_ScreenCentered | #PB_Window_Invisible)
  Protected *Awesomium.Awesomium = Awe_CreateAwesomium(#Awe_Type_Window, Window, Width, Height, Url)
  Protected TI.ToolInfo
  
  awe_webview_set_transparent(*Awesomium\WebView, #True)
  *Awesomium\Image = CreateImage(#PB_Any, Width, Height, 32)
  
  ; create tooltip for whole window
  If hToolTip
    *Awesomium\hToolTip = hToolTip
  Else
    *Awesomium\hToolTip = CreateWindowEx_(0, "Tooltips_Class32", "", 0, 0, 0, 0, 0, 0, 0, 0, 0)
  EndIf
  TI\cbSize = SizeOf(ToolInfo)
  TI\uFlags = #TTF_IDISHWND | #TTF_SUBCLASS
  TI\hwnd = WindowID(*Awesomium\Window)
  TI\uId = WindowID(*Awesomium\Window)
  TI\lpszText = @""
  SendMessage_(*Awesomium\hToolTip, #TTM_ADDTOOL, 0, @TI)

;   StartDrawing(ImageOutput(*Awesomium\Image))
;     DrawingMode(#PB_2DDrawing_AllChannels)
;     Box(0, 0, Width, Height, 0)
;     Debug DrawingBufferPitch()
;     Debug DrawingBufferPixelFormat()
;     Debug ""
;     Debug #PB_PixelFormat_24Bits_RGB  ; 3 Byte pro Pixel (RRGGBB)
;     Debug #PB_PixelFormat_24Bits_BGR  ; 3 Byte pro Pixel (BBGGRR)
;     Debug #PB_PixelFormat_32Bits_RGB  ; 4 Byte pro Pixel (RRGGBB)
;     Debug #PB_PixelFormat_32Bits_BGR 
;     Debug #PB_PixelFormat_ReversedY
;   StopDrawing()
  
  ; from http://www.purebasic.fr/english/viewtopic.php?f=12&t=39079
  SetWindowLong_(WindowID(*Awesomium\Window), #GWL_EXSTYLE, GetWindowLong_(WindowID(*Awesomium\Window), #GWL_EXSTYLE) | #WS_EX_LAYERED)
  HideWindow(*Awesomium\Window, #False)
  ProcedureReturn *Awesomium
EndProcedure

Procedure.i AwesomiumGadget(X.i, Y.i, Width.i, Height.i, Url.s = "")
  Protected Gadget.i = CanvasGadget(#PB_Any, X, Y, Width, Height, #PB_Canvas_Keyboard)
  Protected *Awesomium.Awesomium = Awe_CreateAwesomium(#Awe_Type_Gadget, Gadget, Width, Height, Url)  
  
;   StartDrawing(CanvasOutput(*Awesomium\Gadget))
;     DrawingMode(#PB_2DDrawing_AllChannels)
;     Box(0, 0, Width, Height, 0)
;     Debug DrawingBufferPitch()
;     Debug DrawingBufferPixelFormat()
;     Debug ""
;     Debug #PB_PixelFormat_24Bits_RGB  ; 3 Byte pro Pixel (RRGGBB)
;     Debug #PB_PixelFormat_24Bits_BGR  ; 3 Byte pro Pixel (BBGGRR)
;     Debug #PB_PixelFormat_32Bits_RGB  ; 4 Byte pro Pixel (RRGGBB)
;     Debug #PB_PixelFormat_32Bits_BGR 
;     Debug #PB_PixelFormat_ReversedY   
;   StopDrawing()
  
  ProcedureReturn *Awesomium
EndProcedure

  ; only mode memory or normal allowed, for sprite 3D use below!
Procedure.i CreateAwesomiumSprite(Width.i, Height.i, Mode.i, Url.s = "")
  Protected Sprite.i = CreateSprite(#PB_Any, Width, Height, Mode)
  Protected *Awesomium.Awesomium = Awe_CreateAwesomium(#Awe_Type_Sprite, Sprite, Width, Height, Url)  
  If Mode & #PB_Sprite_AlphaBlending
     ; needed because of DX9 bug: alpha-channel lost on StartDrawing()
    *Awesomium\RepaintEverything = #True
  EndIf
  
;   StartDrawing(SpriteOutput(*Awesomium\Sprite))
;     DrawingMode(#PB_2DDrawing_AllChannels)
;     Box(0, 0, Width, Height, 0)
;     Debug DrawingBufferPitch()
;     Debug DrawingBufferPixelFormat()
;     Debug ""
;     Debug #PB_PixelFormat_24Bits_RGB  ; 3 Byte pro Pixel (RRGGBB)
;     Debug #PB_PixelFormat_24Bits_BGR  ; 3 Byte pro Pixel (BBGGRR)
;     Debug #PB_PixelFormat_32Bits_RGB  ; 4 Byte pro Pixel (RRGGBB)
;     Debug #PB_PixelFormat_32Bits_BGR 
;     Debug #PB_PixelFormat_ReversedY   
;   StopDrawing()
  
  ProcedureReturn *Awesomium
EndProcedure

Procedure.i CreateAwesomiumSprite3D(Width.i, Height.i, Transparent.i, Url.s = "")
  Protected Sprite.i = CreateSprite(#PB_Any, Width, Height, #PB_Sprite_Texture | #PB_Sprite_AlphaBlending)
  Protected Sprite3D.i = CreateSprite3D(#PB_Any, Sprite)
  Protected *Awesomium.Awesomium = Awe_CreateAwesomium(#Awe_Type_Sprite3D, Sprite, Width, Height, Url)  
  *Awesomium\Sprite3D = Sprite3D
  awe_webview_set_transparent(*Awesomium\WebView, #True)
  TransparentSpriteColor(*Awesomium\Sprite, Transparent)
  *Awesomium\RepaintEverything = #True ; needed because of DX9 bug: alpha-channel lost on StartDrawing()
  
;   StartDrawing(SpriteOutput(*Awesomium\Sprite))
;     DrawingMode(#PB_2DDrawing_AllChannels)
;     Box(0, 0, Width, Height, 0)
;     Debug DrawingBufferPitch()
;     Debug DrawingBufferPixelFormat()
;     Debug ""
;     Debug #PB_PixelFormat_24Bits_RGB  ; 3 Byte pro Pixel (RRGGBB)
;     Debug #PB_PixelFormat_24Bits_BGR  ; 3 Byte pro Pixel (BBGGRR)
;     Debug #PB_PixelFormat_32Bits_RGB  ; 4 Byte pro Pixel (RRGGBB)
;     Debug #PB_PixelFormat_32Bits_BGR 
;     Debug #PB_PixelFormat_ReversedY   
;   StopDrawing()
  
  ProcedureReturn *Awesomium
EndProcedure

Procedure.i CreateAwesomiumTexture(Width.i, Height.i, Url.s = "", PowerOf2.i = #True)
  Protected TextureWidth.i = 1, TextureHeight.i = 1
  ;Protected Texture.i = CreateTexture(#PB_Any, Width, Height)
  
  ; texture needs to be 2^X  -  always!
  If PowerOf2
    While TextureWidth < Width
      TextureWidth * 2
    Wend
    While TextureHeight < Height
      TextureHeight * 2
    Wend
  Else
    TextureWidth = Width
    TextureHeight = Height
  EndIf
  ; ------
  
  ; needed because CreateTexture() doesn't have alpha
  Protected Image.i = CreateImage(#PB_Any, TextureWidth, TextureHeight, 32)
  StartDrawing(ImageOutput(Image))
    DrawingMode(#PB_2DDrawing_AllChannels)
    Box(0, 0, ImageWidth(Image), ImageHeight(Image), 0)
  StopDrawing()
  Protected File.s = GetTemporaryDirectory() + Str(Image) + ".png"
  SaveImage(Image, File, #PB_ImagePlugin_PNG)
  FreeImage(Image)
  Protected Texture.i = LoadTexture(#PB_Any, File)
  ; ------  
  
  Protected *Awesomium.Awesomium = Awe_CreateAwesomium(#Awe_Type_Texture, Texture, Width, Height, Url)  
  *Awesomium\Texture = Texture
  awe_webview_set_transparent(*Awesomium\WebView, #True)
  
  ;   StartDrawing(TextureOutput(*Awesomium\Texture))
;     DrawingMode(#PB_2DDrawing_AllChannels)
;     Box(0, 0, Width, Height, 0)
;     Debug DrawingBufferPitch()
;     Debug DrawingBufferPixelFormat()
;     Debug ""
;     Debug #PB_PixelFormat_24Bits_RGB  ; 3 Byte pro Pixel (RRGGBB)
;     Debug #PB_PixelFormat_24Bits_BGR  ; 3 Byte pro Pixel (BBGGRR)
;     Debug #PB_PixelFormat_32Bits_RGB  ; 4 Byte pro Pixel (RRGGBB)
;     Debug #PB_PixelFormat_32Bits_BGR 
;     Debug #PB_PixelFormat_ReversedY
;   StopDrawing()
  
  ProcedureReturn *Awesomium
EndProcedure

Procedure Awesomium_LoadUrl(*Awesomium.Awesomium, Url.s)
  Protected *strUrl
  If Url And *Awesomium
    *Awesomium\Url = Url
    *strUrl = awe_string_create_from_utf16(Url, Len(Url))
    awe_webview_load_url(*Awesomium\WebView, *strUrl, awe_string_empty(), awe_string_empty(), awe_string_empty())
    awe_string_destroy(*strUrl)
  EndIf
EndProcedure

Procedure Awesomium_LoadFile(*Awesomium.Awesomium, File.s, FrameName.s="")
  Protected *file, *frame_name
  If File And *Awesomium
    *file = awe_string_create_from_utf16(File, Len(File))
    If FrameName
      *frame_name = awe_string_create_from_utf16(FrameName, Len(FrameName))
    Else
      *frame_name = awe_string_empty()
    EndIf
    awe_webview_load_file(*Awesomium\WebView, *file, *frame_name)
    awe_string_destroy(*file)
    If FrameName : awe_string_destroy(*frame_name) : EndIf
  EndIf  
EndProcedure

Procedure Awesomium_LoadString(*Awesomium.Awesomium, Html.s, FrameName.s="")
  Protected *html, *frame_name
  If Html And *Awesomium
    *html = awe_string_create_from_utf16(Html, Len(Html))
    If FrameName
      *frame_name = awe_string_create_from_utf16(FrameName, Len(FrameName))
    Else
      *frame_name = awe_string_empty()
    EndIf
    awe_webview_load_html(*Awesomium\WebView, *html, *frame_name)
    awe_string_destroy(*html)
    If FrameName : awe_string_destroy(*frame_name) : EndIf
  EndIf
EndProcedure

Procedure.s Awesomium_GetTitle(ID.i)
  If SelectAwesomium(ID)
    ProcedureReturn Awesomium()\Title
  EndIf
EndProcedure

Procedure.s Awesomium_GetUrl(*Awesomium.Awesomium)
  If *Awesomium
    ProcedureReturn *Awesomium\Url
  EndIf
EndProcedure


Macro CaseKeyCodes(_KEY_, _SHORT_=, _AWE_=)
  CompilerIf Defined(AK_#_AWE_, #PB_Constant) = 0
    CompilerIf Defined(PB_Shortcut_#_SHORT_, #PB_Constant) = 0
    Case #PB_Shortcut_#_KEY_
      keyevent\virtual_key_code = #AK_#_KEY_
      keyevent\native_key_code = #PB_Key_#_KEY_
    CompilerElse
      Case #PB_Shortcut_#_SHORT_
        keyevent\virtual_key_code = #AK_#_SHORT_
        keyevent\native_key_code = #PB_Key_#_KEY_
    CompilerEndIf
  CompilerElse
  Case #PB_Shortcut_#_SHORT_
    keyevent\virtual_key_code = #AK_#_AWE_
    keyevent\native_key_code = #PB_Key_#_KEY_
  CompilerEndIf
EndMacro


Procedure Awesomium_GadgetEvent(*Awesomium.Awesomium, Event.i)
  Protected keyevent.awe_webkeyboardevent
  Protected Char.u, key.i
  Protected Modifiers.i
  
  If *Awesomium And *Awesomium\Type = #Awe_Type_Gadget
    Select Event
      Case #PB_EventType_MouseMove
        awe_webview_inject_mouse_move(*Awesomium\WebView, GetGadgetAttribute(*Awesomium\Gadget, #PB_Canvas_MouseX), GetGadgetAttribute(*Awesomium\Gadget, #PB_Canvas_MouseY))
        
      Case #PB_EventType_LeftButtonDown
        awe_webview_inject_mouse_down(*Awesomium\WebView, #AWE_MB_LEFT)
      Case #PB_EventType_MiddleButtonDown
        awe_webview_inject_mouse_down(*Awesomium\WebView, #AWE_MB_MIDDLE)
      Case #PB_EventType_RightButtonDown
        awe_webview_inject_mouse_down(*Awesomium\WebView, #AWE_MB_Right)

      Case #PB_EventType_LeftButtonUp
        awe_webview_inject_mouse_up(*Awesomium\WebView, #AWE_MB_LEFT)
      Case #PB_EventType_MiddleButtonUp
        awe_webview_inject_mouse_up(*Awesomium\WebView, #AWE_MB_MIDDLE)
      Case #PB_EventType_RightButtonUp
        awe_webview_inject_mouse_up(*Awesomium\WebView, #AWE_MB_RIGHT)
        
      Case #PB_EventType_MouseWheel
        awe_webview_inject_mouse_wheel(*Awesomium\WebView, GetGadgetAttribute(*Awesomium\Gadget, #PB_Canvas_WheelDelta) * 50, 0)
        
      Case #PB_EventType_Focus
        awe_webview_focus(*Awesomium\WebView)
        *Awesomium\hasFocus = #True
        
      Case #PB_EventType_LostFocus
        awe_webview_unfocus(*Awesomium\WebView)
        *Awesomium\hasFocus = #False
        
      Case #PB_EventType_Input
        Char = GetGadgetAttribute(*Awesomium\Gadget, #PB_Canvas_Input)
        keyevent\type = #AWE_WKT_CHAR
        keyevent\text[0] = CHAR
        keyEvent\unmodified_Text[0] = CHAR
        keyevent\virtual_key_code = Char
        keyevent\native_key_code = Char
        awe_webview_inject_keyboard_event(*Awesomium\WebView, keyevent)
      
      Case #PB_EventType_KeyDown, #PB_EventType_KeyUp
        key = GetGadgetAttribute(*Awesomium\Gadget, #PB_Canvas_Key)
        
        With keyevent
          If Event = #PB_EventType_KeyDown
            \type = #AWE_WKT_KEYDOWN
          Else
            \type = #AWE_WKT_KEYUP
          EndIf
          Modifiers = GetGadgetAttribute(*Awesomium\Gadget, #PB_Canvas_Modifiers)
          \modifiers = 0
          If Modifiers & #PB_Canvas_Alt
            \modifiers | #MOD_ALT_KEY
          EndIf
          If Modifiers & #PB_Canvas_Control
            \modifiers | #MOD_CONTROL_KEY
          EndIf
          If Modifiers & #PB_Canvas_Command
            \modifiers | #MOD_META_KEY
          EndIf
          If Modifiers & #PB_Canvas_Shift
            \modifiers | #MOD_SHIFT_KEY
          EndIf
        
          Select key
            CaseKeyCodes(LeftShift, SHIFT)
            CaseKeyCodes(LeftControl, CONTROL)
           
            CaseKeyCodes(Back)
            CaseKeyCodes(Tab)
            ;CaseKeyCodes(Clear, CLEAR)
            CaseKeyCodes(Return)
            ;CaseKeyCodes(Menu, MENU)
            CaseKeyCodes(Pause)
            CaseKeyCodes(Capital)
            CaseKeyCodes(Escape)
            CaseKeyCodes(Space)
            CaseKeyCodes(PageUp, PRIOR)
            CaseKeyCodes(PageDown, Next)
            CaseKeyCodes(End)
            CaseKeyCodes(Home)
            CaseKeyCodes(Left)
            CaseKeyCodes(Up)
            CaseKeyCodes(Right)
            CaseKeyCodes(Down)
            ;CaseKeyCodes(Select, Select)
            ;CaseKeyCodes(Execute, EXECUTE)
            ;CaseKeyCodes(Print, PRINT)
            ;CaseKeyCodes(Snapshot, SNAPSHOT)
            CaseKeyCodes(Insert)
            CaseKeyCodes(Delete)
            ;CaseKeyCodes(Help, HELP)
            
            
            CaseKeyCodes(0)
            CaseKeyCodes(1)
            CaseKeyCodes(2)
            CaseKeyCodes(3)
            CaseKeyCodes(4)
            CaseKeyCodes(5)
            CaseKeyCodes(6)
            CaseKeyCodes(7)
            CaseKeyCodes(8)
            CaseKeyCodes(9)
            CaseKeyCodes(a)
            CaseKeyCodes(b)
            CaseKeyCodes(c)
            CaseKeyCodes(d)
            CaseKeyCodes(e)
            CaseKeyCodes(f)
            CaseKeyCodes(g)
            CaseKeyCodes(h)
            CaseKeyCodes(i)
            CaseKeyCodes(j)
            CaseKeyCodes(k)
            CaseKeyCodes(l)
            CaseKeyCodes(m)
            CaseKeyCodes(n)
            CaseKeyCodes(o)
            CaseKeyCodes(p)
            CaseKeyCodes(q)
            CaseKeyCodes(r)
            CaseKeyCodes(s)
            CaseKeyCodes(t)
            CaseKeyCodes(q)
            CaseKeyCodes(v)
            CaseKeyCodes(w)
            CaseKeyCodes(x)
            CaseKeyCodes(y)
            CaseKeyCodes(z)
            
            CaseKeyCodes(Pad0, Pad0, NUMPAD0)
            CaseKeyCodes(Pad1, Pad1, NUMPAD1)
            CaseKeyCodes(Pad2, Pad2, NUMPAD2)
            CaseKeyCodes(Pad3, Pad3, NUMPAD3)
            CaseKeyCodes(Pad4, Pad4, NUMPAD4)
            CaseKeyCodes(Pad5, Pad5, NUMPAD5)
            CaseKeyCodes(Pad6, Pad6, NUMPAD6)
            CaseKeyCodes(Pad7, Pad7, NUMPAD7)
            CaseKeyCodes(Pad8, Pad8, NUMPAD8)
            CaseKeyCodes(Pad9, Pad9, NUMPAD9)
            
            CaseKeyCodes(F1)
            CaseKeyCodes(F2)
            CaseKeyCodes(F3)
            CaseKeyCodes(F4)
            CaseKeyCodes(F5)
            CaseKeyCodes(F6)
            CaseKeyCodes(F7)
            CaseKeyCodes(F8)
            CaseKeyCodes(F9)
            CaseKeyCodes(F10)
            CaseKeyCodes(F11)
            CaseKeyCodes(F12)
            
          EndSelect
        EndWith
        awe_webview_inject_keyboard_event(*Awesomium\WebView, keyevent)
    EndSelect
  EndIf
EndProcedure

Procedure Awesomium_Resize(*Awesomium.Awesomium, X.i, Y.i, Width.i, Height.i)
  If *Awesomium 
    Select *Awesomium\Type
      Case #Awe_Type_Gadget
        ResizeGadget(*Awesomium\Gadget, X, Y, Width, Height)
        awe_webview_resize(*Awesomium\WebView, Width, Height, #True, 0)
        Awe_RedrawAwesomium_BGR24Y(*Awesomium, #True)
      Case #Awe_Type_Window
        ResizeWindow(*Awesomium\Window, X, Y, Width, Height)
        awe_webview_resize(*Awesomium\WebView, Width, Height, #True, 0)
        ResizeImage(*Awesomium\Image, Width, Height, #PB_Image_Raw)
        StartDrawing(ImageOutput(Awesomium()\Image))
          Awe_RedrawAwesomium_BGR32Y(@Awesomium())
        StopDrawing()
        Awe_WindowBackground(*Awesomium\Window, *Awesomium\Image, 255)
     EndSelect
  EndIf
EndProcedure

Procedure Awesomium_Update()
  Static Image.i
  
  awe_webcore_update()
  
  ForEach Awesomium()
    If awe_webview_is_dirty(Awesomium()\WebView) & %1
      Select Awesomium()\Type
        Case #Awe_Type_Gadget
          Awe_RedrawAwesomium_BGR24Y(@Awesomium())
          
        Case #Awe_Type_Window
          StartDrawing(ImageOutput(Awesomium()\Image))
            Awe_RedrawAwesomium_BGR32Y(@Awesomium())
          StopDrawing()
          Awe_WindowBackground(Awesomium()\Window, Awesomium()\Image, 255)
          
        Case #Awe_Type_Texture
          StartDrawing(TextureOutput(Awesomium()\Texture))
             Awe_RedrawAwesomium_RGB32Y(@Awesomium())
          StopDrawing()
          
        Case #Awe_Type_Sprite, #Awe_Type_Sprite3D
          StartDrawing(SpriteOutput(Awesomium()\Sprite))
            DrawingMode(#PB_2DDrawing_AllChannels)
            Awe_RedrawAwesomium_BGR32(@Awesomium())
          StopDrawing()
          
      EndSelect
    EndIf
  Next
EndProcedure

Macro Awesomium_Shutdown()
  awe_webcore_shutdown()
EndMacro

Procedure Awesomium_Callback(*Awesomium.Awesomium, Type.i, Callback.i)
  If *Awesomium
    Select Type
      Case #Awe_Callback_BeginLoading
        *Awesomium\CB_BeginLoading = Callback
      Case #Awe_Callback_Crashed
        *Awesomium\CB_Crashed = Callback
      Case #Awe_Callback_CursorChange
        *Awesomium\CB_CursorChange = Callback
      Case #Awe_Callback_DomReady
        *Awesomium\CB_DomReady = Callback
      Case #Awe_Callback_DownloadFile
        *Awesomium\CB_DownloadFile = Callback
      Case #Awe_Callback_Favicon
        *Awesomium\CB_Favicon = Callback
      Case #Awe_Callback_FileRequester
        *Awesomium\CB_FileRequester = Callback
      Case #Awe_Callback_FinishLoading
        *Awesomium\CB_FinishLoading = Callback
      Case #Awe_Callback_JSCallback
        *Awesomium\CB_JSCallback = Callback
      Case #Awe_Callback_JSDialog
        *Awesomium\CB_JSDialog = Callback
      Case #Awe_Callback_JSMessage 
        *Awesomium\CB_JSMessage = Callback
      Case #Awe_Callback_OpenExtLink
        *Awesomium\CB_OpenExtLink = Callback
      Case #Awe_Callback_OpenLink
        *Awesomium\CB_OpenLink = Callback
      Case #Awe_Callback_OpenNewLink
        *Awesomium\CB_OpenNewLink = Callback
      Case #Awe_Callback_PageContents
        *Awesomium\CB_PageContents = Callback
      Case #Awe_Callback_PluginCrashed
        *Awesomium\CB_PluginCrashed = Callback
      Case #Awe_Callback_Resource
        *Awesomium\CB_Resource = Callback
      Case #Awe_Callback_ShowContextMenu
        *Awesomium\CB_ShowContextMenu = Callback
      Case #Awe_Callback_TargetChange
        *Awesomium\CB_TargetChange = Callback
      Case #Awe_Callback_Title
        *Awesomium\CB_Title = Callback
      Case #Awe_Callback_Tooltip
        *Awesomium\CB_Tooltip = Callback
    EndSelect
  EndIf
EndProcedure

Procedure Awesomium_ResourceRequestCallback(*Awesomium.Awesomium, Url.s, *Callback)
  If *Awesomium
    If Not *Awesomium\InitResRequest
      NewMap *Awesomium\CB_ResourceRequest.i(16)
      *Awesomium\InitResRequest = #True
    EndIf
    *Awesomium\CB_ResourceRequest(Url) = *Callback
  EndIf
EndProcedure

Procedure Awesomium_RegisterObject(*Awesomium.Awesomium, ObjectName.s)
  Protected *object_name = awe_string_create_from_utf16(ObjectName, Len(ObjectName))
  If *Awesomium
    awe_webview_create_object(*Awesomium\WebView, *object_name)
  EndIf
  awe_string_destroy(*object_name)
EndProcedure

Procedure Awesomium_RegisterObjectCallback(*Awesomium.Awesomium, ObjectName.s, CallbackName.s)
  Protected *object_name = awe_string_create_from_utf16(ObjectName, Len(ObjectName))
  Protected *callback_name = awe_string_create_from_utf16(CallbackName, Len(CallbackName))
  If *Awesomium
    awe_webview_set_object_callback(*Awesomium\WebView, *object_name, *callback_name)
  EndIf 
  awe_string_destroy(*object_name)
  awe_string_destroy(*callback_name)
EndProcedure

Procedure Awesomium_Zoom(*Awesomium.Awesomium, Zoom.i)
  If *Awesomium
    awe_webview_set_zoom(*Awesomium\WebView, Zoom)
  EndIf
EndProcedure 

Procedure Awesomium_BaseDirectory(Path.s)
  Protected *path = awe_string_create_from_utf16(Path, Len(Path))
  awe_webcore_set_base_directory(*path)
  awe_string_destroy(*path)
EndProcedure
  

Procedure.i Awesomium_IsWindow(*Awesomium.Awesomium)
  If *Awesomium And *Awesomium\Type = #Awe_Type_Window
    ProcedureReturn #True
  EndIf
  ProcedureReturn #False
EndProcedure

Procedure.i Awesomium_IsGadget(*Awesomium.Awesomium)
  If *Awesomium And *Awesomium\Type = #Awe_Type_Gadget
    ProcedureReturn #True
  EndIf
  ProcedureReturn #False
EndProcedure

Procedure.i Awesomium_GetGadget(*Awesomium.Awesomium)
  If *Awesomium And *Awesomium\Type = #Awe_Type_Gadget
    ProcedureReturn *Awesomium\Gadget
  EndIf
  ProcedureReturn #Null
EndProcedure

Procedure.i Awesomium_GetWindow(*Awesomium.Awesomium)
  If *Awesomium And *Awesomium\Type = #Awe_Type_Window
    ProcedureReturn *Awesomium\Window
  EndIf
  ProcedureReturn #Null
EndProcedure

Procedure.i Awesomium_GetSprite(*Awesomium.Awesomium)
  If *Awesomium And (*Awesomium\Type = #Awe_Type_Sprite Or *Awesomium\Type = #Awe_Type_Sprite3D)
    ProcedureReturn *Awesomium\Sprite
  EndIf
  ProcedureReturn #Null
EndProcedure

Procedure.i Awesomium_GetSprite3D(*Awesomium.Awesomium)
  If *Awesomium And *Awesomium\Type = #Awe_Type_Sprite3D
    ProcedureReturn *Awesomium\Sprite3D
  EndIf
  ProcedureReturn #Null
EndProcedure

Procedure.i Awesomium_GetTexture(*Awesomium.Awesomium)
  If *Awesomium And *Awesomium\Type = #Awe_Type_Texture
    ProcedureReturn *Awesomium\Texture
  EndIf
  ProcedureReturn #Null
EndProcedure

Procedure.i Awesomium_IsAwesomium(ID.i, Type.i = -1)
  LockMutex(AwesomiumMutex)
  ForEach Awesomium()
    If Awesomium()\ID = ID  
      If Type = -1 Or Type = Awesomium()\Type
        UnlockMutex(AwesomiumMutex)
        ProcedureReturn @Awesomium()
      Else
        Break
      EndIf
    EndIf
  Next
  UnlockMutex(AwesomiumMutex)
  ProcedureReturn #Null
EndProcedure

Macro Awesomium_GetAwesomium(ID, Type=-1)
  Awesomium_IsAwesomium(ID, Type)
EndMacro

Procedure Awesomium_InjectMousePos(*Awesomium.Awesomium, X.i, Y.i)
  If *Awesomium
    awe_webview_inject_mouse_move(*Awesomium\WebView, X, Y)
  EndIf
EndProcedure

Procedure Awesomium_InjectMouseButton(*Awesomium.Awesomium, btnLeft.i, btnMiddle.i, btnRight.i)
  If *Awesomium
    If btnLeft
      If Not *Awesomium\Button[0]
        *Awesomium\Button[0] = #True
        awe_webview_inject_mouse_down(*Awesomium\WebView, #AWE_MB_LEFT)
      EndIf
    Else
      If *Awesomium\Button[0]
        *Awesomium\Button[0] = #False
        awe_webview_inject_mouse_up(*Awesomium\WebView, #AWE_MB_LEFT)
      EndIf
    EndIf
    If btnMiddle
      If Not *Awesomium\Button[1]
        *Awesomium\Button[1] = #True
        awe_webview_inject_mouse_down(*Awesomium\WebView, #AWE_MB_MIDDLE)
      EndIf
    Else
      If *Awesomium\Button[1]
        *Awesomium\Button[1] = #False
        awe_webview_inject_mouse_up(*Awesomium\WebView, #AWE_MB_MIDDLE)
      EndIf
    EndIf
    If btnRight
      If Not *Awesomium\Button[2]
        *Awesomium\Button[2] = #True
        awe_webview_inject_mouse_down(*Awesomium\WebView, #AWE_MB_RIGHT)
      EndIf
    Else
      If *Awesomium\Button[2]
        *Awesomium\Button[2] = #False
        awe_webview_inject_mouse_up(*Awesomium\WebView, #AWE_MB_RIGHT)
      EndIf
    EndIf
  EndIf
EndProcedure

Macro Awesomium_InjectMouseButtonDX(_Awesomium_)
  Awesomium_InjectMouseButton(_Awesomium_, MouseButton(#PB_MouseButton_Left), MouseButton(#PB_MouseButton_Middle), MouseButton(#PB_MouseButton_Right))
EndMacro

Procedure Awesomium_InjectMouseWheel(*Awesomium.Awesomium, ScrollVertical.i, ScrollHorizontal.i)
  If *Awesomium
    awe_webview_inject_mouse_wheel(*Awesomium\WebView, ScrollVertical, ScrollHorizontal)
  EndIf
EndProcedure


Procedure Awesomium_JS_InnerHTML(*Awesomium.Awesomium, FrameName.s, ID.s, HTML.s)
  Protected *javascript, *frame_name
  Protected Javascript.s = "var element = document.getElementById('" + ID + "');"
  Javascript + "if (element) { element.innerHTML = '" + HTML + "'; }"
  *javascript = awe_string_create_from_utf16(Javascript, Len(Javascript))
  
  If FrameName
    *frame_name = awe_string_create_from_utf16(FrameName, Len(FrameName))
  Else
    *frame_name = awe_string_empty()
  EndIf
  
  awe_webview_execute_javascript(*Awesomium\WebView, *javascript, *frame_name)
  awe_string_destroy(*javascript)
  If FrameName
    awe_string_destroy(*frame_name)
  EndIf
EndProcedure

Procedure Awesomium_JS_InnerText(*Awesomium.Awesomium, FrameName.s, ID.s, Text.s)
  Protected *javascript, *frame_name
  Protected Javascript.s = "var element = document.getElementById('" + ID + "');"
  Javascript + "if (element) { element.innerText = '" + Text + "'; }"
  *javascript = awe_string_create_from_utf16(Javascript, Len(Javascript))
  
  If FrameName
    *frame_name = awe_string_create_from_utf16(FrameName, Len(FrameName))
  Else
    *frame_name = awe_string_empty()
  EndIf
  
  awe_webview_execute_javascript(*Awesomium\WebView, *javascript, *frame_name)
  awe_string_destroy(*javascript)
  If FrameName
    awe_string_destroy(*frame_name)
  EndIf
EndProcedure

Procedure Awesomium_JS_Execute(*Awesomium.Awesomium, FrameName.s, Javascript.s, TimeOut.i = 0)
  Protected *frame_name, *javascript
  
  If FrameName
    *frame_name = awe_string_create_from_utf16(FrameName, Len(FrameName))
  Else
    *frame_name = awe_string_empty()
  EndIf
  
  *javascript = awe_string_create_from_utf16(Javascript, Len(Javascript))
  awe_webview_execute_javascript(*Awesomium\WebView, *javascript, *frame_name)
  awe_string_destroy(*javascript)
  If FrameName : awe_string_destroy(*frame_name) : EndIf
EndProcedure

; remember to call awe_jsvalue_destroy(*result) after finished with the result value!
Procedure.i Awesomium_JS_Execute_Return_JSValue(*Awesomium.Awesomium, FrameName.s, Javascript.s, Timeout.i = 0)
  Protected *javascript, *jsResult, *frame_name
  
  If FrameName
    *frame_name = awe_string_create_from_utf16(FrameName, Len(FrameName))
  Else
    *frame_name = awe_string_empty()
  EndIf
    
  Javascript = "(function(){" + Javascript + "})();"
  *javascript = awe_string_create_from_utf16(Javascript, Len(Javascript))
  *jsResult = awe_webview_execute_javascript_with_result(*Awesomium\WebView, *javascript, *frame_name, TimeOut)
  awe_string_destroy(*javascript)
  If FrameName : awe_string_destroy(*frame_name) : EndIf
  
  ProcedureReturn *jsResult
EndProcedure

Procedure.s Awesomium_JS_Execute_Return_String(*Awesomium, FrameName.s, Javascript.s, TimeOut.i = 0)
  Protected *jsResult, *strResult
  Protected Result.s
    
  *jsResult = Awesomium_JS_Execute_Return_JSValue(*Awesomium, FrameName, JavaScript, TimeOut)
  *strResult = awe_jsvalue_to_string(*jsResult)
  Result = awe_string_get_string(*strResult)
  awe_string_destroy(*strResult)
  awe_jsvalue_destroy(*jsResult)
  ProcedureReturn Result
EndProcedure

Procedure.i Awesomium_JS_Execute_Return_Int(*Awesomium, FrameName.s, Javascript.s, TimeOut.i = 0)
  Protected *jsResult, *strResult
  Protected Result.i
    
  *jsResult = Awesomium_JS_Execute_Return_JSValue(*Awesomium, FrameName, JavaScript, TimeOut)
  Result = awe_jsvalue_to_integer(*jsResult)
  awe_jsvalue_destroy(*jsResult)
  ProcedureReturn Result
EndProcedure

Procedure.d Awesomium_JS_Execute_Return_Double(*Awesomium, FrameName.s, Javascript.s, TimeOut.i = 0)
  Protected *jsResult, *strResult
  Protected Result.d
    
  *jsResult = Awesomium_JS_Execute_Return_JSValue(*Awesomium, FrameName, JavaScript, TimeOut)
  Result = awe_jsvalue_to_double(*jsResult)
  awe_jsvalue_destroy(*jsResult)
  ProcedureReturn Result
EndProcedure

CompilerIf Defined(jsonObj, #PB_Structure)
Procedure Awesomium_JSValue_To_jsonObj(*jsValue, *jsonObj.jsonObj)
  Protected *str, *jsArray, *jsObject
    
  Select awe_jsvalue_get_type(*jsValue)
    Case #JSVALUE_TYPE_NULL
      *jsonObj\type = #JSON_Type_Null
      
    Case #JSVALUE_TYPE_BOOLEAN
      If awe_jsvalue_to_boolean(*jsValue)
        *jsonObj\type = #JSON_Type_True
      Else
        *jsonObj\type = #JSON_Type_False
      EndIf
      
    Case #JSVALUE_TYPE_INTEGER
      *jsonObj\type = #JSON_Type_Integer
      *jsonObj\i = awe_jsvalue_to_integer(*jsValue)
      
    Case #JSVALUE_TYPE_DOUBLE
      *jsonObj\type = #JSON_Type_Float
      *jsonObj\f = awe_jsvalue_to_double(*jsValue)
      
    Case #JSVALUE_TYPE_STRING
      *jsonObj\type = #JSON_Type_String
      *str = awe_jsvalue_to_string(*jsValue)
      *jsonObj\s = awe_string_get_string(*str)
      awe_string_destroy(*strResult)
      
    Case #JSVALUE_TYPE_ARRAY
      *jsonObj\type = #JSON_Type_Array
      *jsArray = awe_jsvalue_get_array(*jsValue)
      JSON_dimArray(*jsonObj, awe_jsarray_get_size(*jsArray))
      For i = 0 To *jsonObj\length - 1
        *jsValue = awe_jsarray_get_element(*jsArray, i)
        Awesomium_JSValue_To_jsonObj(*jsValue, @*jsonObj\a(i))
        awe_jsvalue_destroy(*jsValue)
      Next
      awe_jsarray_destroy(*jsArray)
      
    Case #JSVALUE_TYPE_OBJECT
      *jsonObj\type = #JSON_Type_Object
      *jsObject = awe_jsvalue_get_object(*jsValue)
      *jsArray = awe_jsobject_get_keys(*jsObject)
      For i = 0 To awe_jsarray_get_size(*jsArray) - 1
        *string = awe_jsarray_get_element(*jsArray, i)
        *jsonObj\o(awe_string_get_string(*string))
        *jsValue = awe_jsobject_get_property(*jsObject, *string)
        awe_string_destroy(*string)
        Awesomium_JSValue_To_jsonObj(*jsValue, @*jsonObj\o())
        awe_jsvalue_destroy(*jsValue)
      Next
      awe_jsarray_destroy(*jsArray)
      awe_jsobject_destroy(*jsObject)
      
      
  EndSelect
EndProcedure
  
Procedure.i Awesomium_JS_Execute_Return_jsonObj(*Awesomium, FrameName.s, Javascript.s, *jsonObj.jsonObj, TimeOut.i = 0)
  Protected *jsResult, *strResult
  Protected Result.i = #False
    
  *jsResult = Awesomium_JS_Execute_Return_JSValue(*Awesomium, FrameName, JavaScript, TimeOut)
  If *jsResult
    Awesomium_JSValue_To_jsonObj(*jsResult, *jsonObj)
    Result = #True
    awe_jsvalue_destroy(*jsResult)
  EndIf
  
  ProcedureReturn Result  
EndProcedure
CompilerEndIf

Macro Awesomium_CancleRequest(Awesomium_Request)
  Awesomium_Request\Cancle = #True
EndMacro

Procedure.i Awesomium_CreateResponse(*Buffer, Size.i, MimeType.s)
  Protected *mime_type = awe_string_create_from_utf16(MimeType, Len(MimeType))
  Protected *response = awe_resource_response_create(Size, *Buffer, *mime_type)
  awe_string_destroy(*mime_type)
  ProcedureReturn *response
EndProcedure


Procedure.i Awesomium_HistoryGoTo(*Awesomium.Awesomium, Offset.i)
  Protected HistorySteps.i = 0
  
  If *Awesomium
    If Offset > 0
      HistorySteps = awe_webview_get_history_forward_count(*Awesomium\WebView)
      If Offset > HistorySteps
        Offset = HistorySteps
      EndIf
      HistorySteps - Offset
      awe_webview_go_to_history_offset(*Awesomium\WebView, Offset)
    ElseIf Offset < 0
      HistorySteps = awe_webview_get_history_back_count(*Awesomium\WebView)
      If -Offset > HistorySteps
        Offset = -HistorySteps
      EndIf
      HistorySteps + Offset
      awe_webview_go_to_history_offset(*Awesomium\WebView, Offset)
    EndIf
  EndIf
  
  ProcedureReturn HistorySteps
EndProcedure

Procedure.i Awesomium_HistoryBackwardCount(*Awesomium.Awesomium)
  If *Awesomium
    ProcedureReturn awe_webview_get_history_back_count(*Awesomium\WebView)
  EndIf
EndProcedure

Procedure.i Awesomium_HistoryForwardCount(*Awesomium.Awesomium)
  If *Awesomium
    ProcedureReturn awe_webview_get_history_forward_count(*Awesomium\WebView)
  EndIf
EndProcedure



; ;- Example 
; ; you need the Awesomium SDK, install it somewhere and point to the DLL shipped with it
; #Awesomium_DLL = "C:\Program Files (x86)\Awesomium SDK\1.6.3\build\bin\release\Awesomium.dll"
; 
; ;#Awesomium_DLL = "E:\Programmierung\Tools\Awesomium SDK\1.6.3\build\bin\release\Awesomium.dll"
; InitAwesomium(#Awesomium_DLL, "Awesomium - Test", #True, GetPathPart(ProgramFilename()))
; 
; 
; Global EndProgram = #False
; Procedure JSCallback(ID.i, ObjectName.s, CallbackName.s, *Arguments)
;   Select ObjectName
;     Case "btnClose"
;       EndProgram = #True
;   EndSelect
; EndProcedure
; 
; 
; Define Window.i, Gadget.i, Event.i
; Window = OpenAwesomiumWindow(0, 0, 1024, 768, "Awesomium + PureBasic - Browser Example", "http://www.webkit.org/blog/138/css-animation/")
; Awesomium_LoadFile(Window, "BYD.html")
; ;Awesomium_LoadUrl(Window, "http://tumblr.gesteves.com/post/475773360/css-glow-effects-With-box-shadow")
; 
; Awesomium_RegisterObject(Window, "btnClose")
; Awesomium_RegisterObjectCallback(Window, "btnClose", "close")
; Awesomium_Callback(Window, #Awe_Callback_JSCallback, @JSCallback())
; 
; Repeat
;   UpdateAwesomium()
; 
;   Event =  WaitWindowEvent(10)
;   Select Event
;     Case #PB_Event_CloseWindow
;       Break
;   EndSelect
; Until EndProgram
; awe_webcore_shutdown()
; 
; EndDataSection
; IDE Options = PureBasic 4.61 (Windows - x86)
; CursorPosition = 8
; Folding = ----------
; EnableUnicode
; EnableXP
; EnableUser
; CompileSourceDirectory